(******************************************************************************
 * ACButton                                                                   *
 *                                                                            *
 * Sabato, 01/08/1998                                                         *
 *         sono state aggiunte le properieta "Default" e "Cancel"             *
 * Domenica, 02/08/1998                                                       *
 *         E' stata agginta la propriet "AsButton", quando questa  "True"   *
 *         viene visualizzato un bottone, quando  false una "Label"          *
 * Venerd, 19/03/2004                                                        *
 *         Sono stati inserite delle chiamate per registrare un file di LOG,  *
 *         (a causa di alcuni problemi trovati sun un PC con win95 e          *
 *         scheda video S3)                                                   *
 *         (Solo temporaneamente)                                             *
 * Sabato, 27/03/2004                                                         *
 *         Corretto il problema scoperto il 19/03/2004                        *
 *         Con la prima versione di windows i bottoni non funzionavano.       *
 *         Ho dovuto cambiare il modo in cui venivano distrutti le regioni,   *
 *         ora la memoria viene rilasciata solo quando le regioni non servono *
 *         piu' e non dopo l'assegnamento (SetWindowRgn) e nel distruttore    *
 * Marted, 13/04/2004                                                        *
 *         Il ridisegnamento sulla funzione "mouse_up" dava dei problemi,     *
 *          stata  spostata sulla funzione "mouse_move"                      *
 *         (in alcuni casi bloccava il tasto tab nel passaggio da un          *
 *          controllo all'altro)                                              *
 ******************************************************************************)
unit ACButton;

(******************************************************************************
 * Interface                                                                  *
 ******************************************************************************)
 interface
{$i AcDefinizioni.pas }
(******************************************************************************
 * Uses                                                                       *
 ******************************************************************************)
 uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  ExtCtrls, StdCtrls {$ifdef AC_DEBUG_MODE} ,AC_Debug_Unit{$endif};



(******************************************************************************
 * Type                                                                       *
 ******************************************************************************)
 type                         //tbutton
  TACButton = class(TCustomPanel)
  private
    { Private declarations }
    Is_Mouse_Dentro : Boolean;
    Bmp1,
    Bmp2,
    Bmp3,
    Bmp4  : TBitMap;
    Is_Mouse_Down : Boolean; (* Indica se il bottone del mouse  premuto *)
    Stato_Mouse  : Integer;  (* Indica dove si trova il mouse Dentro/Fuori Premuto o no *)
                             (* -1: Valore non impostato, all'inizio *)
    xPos, yPos : Integer;    (* Indicano la posizione del mouse *)
    F_Default,               (* Indica che il bottone  quello di default *)
                             (* richiamabile con l'"Invio" (enter)        *)
    F_Cancel     : Boolean;  (* Indica che il bottone  richiamabile con  *)
                             (* l'"Esc"                                   *)
    F_AsButton   : Boolean;  (* Indica se deve avere la forma di un buttone *)
                             (* o di una label                              *)
    F_BackColor  : TColor;   (* Colore di fondo                             *)
    h_regione    : Integer;  (* Handle della regione della finestra *)
    forza_fuori  : Boolean;  (* forza il disgno del mouse come se il cursore fosse fuori*)


  protected
    { Protected declarations }
    procedure paint;override;
    procedure mouse_move(var Msg: TMessage); Message wm_mousemove;
    procedure mouse_down(var Msg: TMessage); Message WM_LBUTTONDOWN;
    procedure mouse_up(var Msg: TMessage); Message WM_LBUTTONUP ;
    procedure win_size(var Msg: TMessage); Message WM_SIZE ;
    procedure old_paint;
    procedure disegna_bitmap(x:Integer);
    procedure KeyAccel(var Message: TCMDialogChar); message CM_DIALOGCHAR;
    Procedure Set_AsButton(Fl:boolean);
    Procedure Set_BackColor(t:TColor);

    procedure Make_Shape;
    procedure CMMouseEnter(Var Msg : TMessage); message CM_MOUSEENTER;
    procedure CMMouseLeave(Var Msg : TMessage); message CM_MOUSELEAVE;


  public
    { Public declarations }
    constructor Create(AOwner: TComponent);override;
    destructor Destroy; override;
  published
    { Published declarations }
    property Caption ;
    property OnClick;
    Property Cancel  : Boolean Read F_Cancel Write F_Cancel;
    Property Default : Boolean Read F_Default Write F_Default;
    Property AsButton : Boolean Read F_AsButton Write Set_AsButton;
    Property Visible;
    Property BackColor : TColor Read F_BackColor Write Set_BackColor;
    Property Font;
  end;

(******************************************************************************
 * Implementation                                                             *
 ******************************************************************************)
implementation

(*$r AcButtonResource.Res *)

(******************************************************************************
 * Paint                                                                      *
 ******************************************************************************)
procedure TAcButton.paint;
Const diff = 1;
//Var
//   h1,h2 : Integer;
//  Aggiunta : Integer;
Begin
//;inherited;
  old_paint;
  if(Is_Mouse_Dentro) then
  begin
    Canvas.Pen.Color := clBlack;
    Canvas.Pen.Color := clGray;
    Canvas.Pen.Width := 2;
    if (AsButton) then Canvas.RoundRect(0,0,width,height,height,height);
    Canvas.Pen.Width := 1;
    Canvas.Pen.Color := clSilver;
    if (AsButton) then
    begin
      Canvas.RoundRect(DIFF,DIFF,width-DIFF,height-DIFF,height-DIFF,height-DIFF);
    End;
    canvas.brush.color := BackColor;
    if(is_Mouse_down) then disegna_bitmap(3)
    else disegna_bitmap(2)
  end
  Else
  Begin
    Canvas.Pen.Color := clSilver;
    Canvas.Pen.Width := 1;
    if (AsButton) then
    begin
      Canvas.RoundRect(0,0,width,height,height,height);
    End;
    canvas.brush.color := BackColor;
    disegna_bitmap(1);


  End;
End;


(******************************************************************************
 * Mouse Move                                                                 *
 *                                                                            *
 * Stato_Mouse                                                                *
 *        11: Dentro + Tasto Sinistro Premuto                                 *
 *        10: Dentro + Tasto Sinistro Non premuto                             *
 *        21: Fuori + Tasto Sinistro Premuto                                  *
 *        20: Fuori + Tast o sinistro non Premuto                             *
 ******************************************************************************)
procedure TACButton.mouse_Move(var Msg: TMessage);
begin
  xPos := LOWORD(msg.lParam)+Left;
  yPos := HIWORD(msg.lParam)+Top;
  is_mouse_down := (msg.wparam and MK_LBUTTON)<>0;

  inherited;
end;

(******************************************************************************
 * Constructor                                                                *
 ******************************************************************************)
constructor TACButton.Create(AOwner: TComponent);
begin
  inherited;
  forza_fuori      := False;
  Stato_Mouse      := -1;
  xPos             := 0;
  yPos             := 0;
  h_regione        := -1;
  Is_Mouse_Dentro  := False;
  BevelInner       := bvNone;
  BevelOuter       := bvNone;
  BackColor        := clInfoBk;
  Bmp1             := TBitMap.Create;
  Bmp2             := TBitMap.Create;
  Bmp3             := TBitMap.Create;
  Bmp4             := TBitMap.Create;
  Bmp1.LoadFromResourceName(hInstance,'TACButton1');
  Bmp2.LoadFromResourceName(hInstance,'TACButton2');
  Bmp3.LoadFromResourceName(hInstance,'TACButton3');
  Is_Mouse_Down := False;

  AsButton := True;
end;

(******************************************************************************
 * Mouse Down                                                                 *
 ******************************************************************************)
procedure TACButton.mouse_down(var Msg: TMessage); //Message wm_mouseDown;
begin
  inherited;
  Is_Mouse_Down := True;
  Invalidate;
end;


(******************************************************************************
 * Mouse Up                                                                   *
 ******************************************************************************)
procedure TACButton.mouse_up(var Msg: TMessage); //Message wm_mouseDown;
begin
  Stato_mouse := -1;
  Is_Mouse_Down := False;
  Invalidate;
  inherited;
end;

(******************************************************************************
 * Destructor                                                                 *
 ******************************************************************************)
destructor TACButton.Destroy;
begin
 if(h_regione>0) then DeleteObject(h_regione); // Se la regione  gi stata allocata prima
 h_regione := 0;
 Bmp1.Free;
 Bmp2.Free;
 Bmp3.Free;
 Bmp4.Free;
 Inherited;
end;

(******************************************************************************
 * Old_Paint                                                                  *
 ******************************************************************************)
procedure TACButton.old_paint;
var
  Rect: TRect;
  TopColor, BottomColor: TColor;
  FontHeight: Integer;
  Aggiunta : Integer;
const
  Alignments: array[TAlignment] of Word = (DT_LEFT, DT_RIGHT, DT_CENTER);

  procedure AdjustColors(Bevel: TPanelBevel);
  begin
    TopColor := clBtnHighlight;
    if Bevel = bvLowered then TopColor := clBtnShadow;
    BottomColor := clBtnShadow;
    if Bevel = bvLowered then BottomColor := clBtnHighlight;
  end;

begin

  if(is_mouse_down)and(AsButton) then aggiunta := 1
  else aggiunta := 0;

  Rect := GetClientRect;
  if BevelOuter <> bvNone then
  begin
    AdjustColors(BevelOuter);
    Frame3D(Canvas, Rect, TopColor, BottomColor, BevelWidth);
  end;
  Frame3D(Canvas, Rect, Color, Color, BorderWidth);
  if BevelInner <> bvNone then
  begin
    AdjustColors(BevelInner);
    Frame3D(Canvas, Rect, TopColor, BottomColor, BevelWidth);
  end;
  with Canvas do
  begin
    Brush.Color := BackColor;
    FillRect(Rect);
    Brush.Style := bsClear;
    Font := Self.Font;
    FontHeight := TextHeight('W');
    with Rect do
    begin
      Top := ((Bottom + Top) - FontHeight) div 2;
      Bottom := Top + FontHeight;
    end;
    Rect.Top := Rect.Top + Aggiunta;
    Rect.Bottom := Rect.Bottom + Aggiunta;
    if (asButton) then
    begin
      DrawText(Handle, PChar(Caption), -1, Rect, (DT_EXPANDTABS or
        DT_VCENTER) or Alignments[taCenter]);
    end
    Else
    begin
       Rect.Left := Bmp1.Canvas.ClipRect.Right-Bmp1.Canvas.ClipRect.Left+5+10;
       DrawText(Handle, PChar(Caption), -1, Rect, (DT_EXPANDTABS or
         DT_VCENTER) or Alignments[taLeftJustify]);
    End;
  end;
End;


(******************************************************************************
 * disegna_bitmap                                                             *
 ******************************************************************************)
procedure TACButton.disegna_bitmap(x:Integer);
var
 Aggiunta : Integer;
 Larg,               // Altezza immagine
 Altz   : Integer;   // Larghezza Immagine

begin

  if(is_mouse_down)and(AsButton) then aggiunta := 1
  else aggiunta := 0;
  Altz := Bmp1.Canvas.ClipRect.Bottom-Bmp1.Canvas.ClipRect.top;
  Larg := Bmp1.Canvas.ClipRect.Right-Bmp1.Canvas.ClipRect.Left;

 case x of
 1:
  canvas.BrushCopy(Rect(5,aggiunta+(Height-Altz)div 2,5+Larg,aggiunta+Altz+(Height-Altz)div 2),
                   Bmp1,
                   Bmp1.Canvas.ClipRect,
                   Bmp1.Canvas.pixels[0,0]);

 2:
  canvas.BrushCopy(Rect(5,aggiunta+(Height-Altz)div 2,5+Larg,aggiunta+Altz+(Height-Altz)div 2),
                   Bmp2,
                   Bmp2.Canvas.ClipRect,
                   Bmp2.Canvas.pixels[0,0]);

 3:
  canvas.BrushCopy(Rect(5,aggiunta+(Height-Altz)div 2,5+Larg,aggiunta+Altz+(Height-Altz)div 2),
                   Bmp3,
                   Bmp3.Canvas.ClipRect,
                   Bmp3.Canvas.pixels[0,0]);

 end;

end;

(******************************************************************************
 * KeyAccel                                                                   *
 ******************************************************************************)
procedure TACButton.KeyAccel(var Message: TCMDialogChar);
begin
  with Message do
  begin
    if (Enabled) then
    begin
(********** se  il tasto di scelta rapida **********)
      if IsAccel(CharCode, Caption) then
      begin
        Click;
        Result := 1;
      end
(********** se il tasto  di default e si  premuto "Invio" **********)
      Else if (CharCode=13) and (Default) then
      begin
        Click;
        Result := 1;
      end
(********** se il tasto  di Annullo e si  premuto "Esc" **********)
      Else if (CharCode=27) and (Cancel) then
      begin
        Click;
        Result := 1;
      end

    End
    else inherited;
  end;
end;

(******************************************************************************
 * Set_AsButton                                                               *
 ******************************************************************************)
Procedure TACButton.Set_AsButton(Fl:boolean);
Begin
  F_AsButton := Fl;
  if (assigned(parent)) then Make_Shape;
  Invalidate;
end;

(******************************************************************************
 * Make_Shape                                                                 *
 ******************************************************************************)
procedure TACButton.Make_Shape;
begin
//********** Imposta forma finestra *********
  if (Not asbutton) then
  begin
 //   Hr  := CreateRectRgn(0, 0, 0, 0);
    if(h_regione>0) then DeleteObject(h_regione); // Se la regione  gi stata allocata prima
    h_regione := CreateRectRgn(0,0,Width,Height);
    {$ifdef AC_DEBUG_MODE}
      if  not (csDesigning in ComponentState) then
      begin
         if (h_regione=0) then
         begin
           ac_debug_add_text('           Errore nella creazione della regione (1000)');
           ac_debug_add_text('           Dati Regione: '+intToStr(width)+' ' +intToStr(height)+ ' ');
         end;
      end;

    {$endif}

    SetWindowRgn(handle, h_regione,true);
    //DeleteObject(hr1);
  end
  else
  begin
    if(h_regione>0) then DeleteObject(h_regione); // Se la regione  gi stata allocata prima
    h_regione := CreateRoundRectRgn(0,0,Width+1,Height+1,height,height);
    SetWindowRgn(handle, h_regione,true);
    //DeleteObject(hr1);

  end;
end;


(******************************************************************************
 * win_size                                                                   *
 ******************************************************************************)
procedure TACButton.win_size(var Msg: TMessage);
begin
  inherited;
  Make_Shape;
end;

(******************************************************************************
 * Set_BackColor                                                              *
 ******************************************************************************)
Procedure TACButton.Set_BackColor(t:TColor);
Begin
  F_BackColor := t;
  Invalidate;
End;

(******************************************************************************
 * CMMouseEnter                                                               *
 ******************************************************************************)
procedure TACButton.CMMouseEnter(Var Msg : TMessage);
Begin
  Inherited;
  Is_Mouse_Dentro := True;
  Invalidate;
End;

(******************************************************************************
 * CMMouseLeave                                                               *
 ******************************************************************************)
procedure TACButton.CMMouseLeave(Var Msg : TMessage);
Begin
  Inherited;
  Is_Mouse_Dentro := False;
  Invalidate;
End;

end.
