(******************************************************************************
 * EdFName                                                                    *
 ******************************************************************************)
unit AcEdFName;
{$i AcDefinizioni.pas }
(******************************************************************************
 * interface                                                                  *
 ******************************************************************************)
interface

(******************************************************************************
 * Uses                                                                       *
 ******************************************************************************)
Uses SysUtils, Controls, Classes, Forms 
{$IFDEF DELPHI2}
     ,DsgnIntf
{$ENDIF}
{$IFDEF DELPHI6}
     ,DesignIntf,DesignEditors
{$ENDIF};

(******************************************************************************
 * TFileNameProperty                                                          *
 ******************************************************************************)
{$IFDEF DELPHI2}
 type TFileNameProperty = Class(TStringProperty)
{$ENDIF}
{$IFDEF DELPHI6}
 type TFileNameProperty = Class(TPropertyEditor)
{$ENDIF}
 public
   procedure Edit; override;
   function GetAttributes : TPropertyAttributes; override;
//   function GetValue: string; override;
 end;

(******************************************************************************
 * implementation                                                             *
 ******************************************************************************)
implementation

(******************************************************************************
 * Uses                                                                       *
 ******************************************************************************)
Uses Dialogs, AcLibForm;

(******************************************************************************
 * Edit                                                                       *
 ******************************************************************************)
procedure TFileNameProperty.Edit;
Var //Dlg : TOpenDialog;
   FormComp : TACLibFormComp;
begin
  FormComp := nil;
  try
    //dlg := TOpenDialog.Create(Application);
    FormComp := TACLibFormComp.Create(Application);
    FormComp.OpenDialog1.Filter := 'Log|*.Log';
    FormComp.OpenDialog1.Options := [ofPathMustExist,ofFileMustExist];
    if (FormComp.OpenDialog1.Execute) then SetValue(FormComp.OpenDialog1.FileName);
  finally
    if (FormComp<>nil) then FormComp.Free;
  end;
end;

(******************************************************************************
 * GetAttributes                                                              *
 ******************************************************************************)
function TFileNameProperty.GetAttributes : TPropertyAttributes;
begin
  Result:=inherited GetAttributes+[paDialog, paMultiSelect];
end;


end.
