(******************************************************************************
 * AcEditBox                                                                  *
 ******************************************************************************)
unit AcEditBox;

(******************************************************************************
 * interface                                                                  *
 ******************************************************************************)
interface

(******************************************************************************
 * uses                                                                       *
 ******************************************************************************)
uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls;

(******************************************************************************
 * type                                                                       *
 ******************************************************************************)
type
  TAcEditBox = class(TEdit)
  private
    F_align : TAlignment;
    { Private declarations }
  protected
    { Protected declarations }
  public
    { Public declarations }
    procedure Set_Alignment(Value: TAlignment);
    constructor Create(AOwner: TComponent); Override;
    procedure CreateParams(var Params: TCreateParams); override;
  published
    property Alignment : TAlignment Read F_Align Write Set_Alignment;
    { Published declarations }
  end;


(******************************************************************************
 * implementation                                                             *
 ******************************************************************************)
implementation

(******************************************************************************
 * Create                                                                     *
 ******************************************************************************)
constructor TAcEditBox.Create(AOwner: TComponent);
Begin
  inherited;
  Alignment  := taCenter;

End;

(******************************************************************************
 * CreateParams                                                               *
 ******************************************************************************)
procedure TAcEditBox.CreateParams(var Params: TCreateParams);
const
  Alignments:  array[TAlignment] of UINT = (DT_LEFT, DT_RIGHT, DT_CENTER);
begin
  inherited CreateParams(Params);
  Params.Style := Params.Style or WS_CLIPCHILDREN  or Alignments[F_Align];
end;

(******************************************************************************
 * Set_Alignment                                                              *
 ******************************************************************************)
procedure TAcEditBox.Set_Alignment(Value: TAlignment);
begin
  if Value <> F_Align then
  begin
    F_Align := Value;
    RecreateWnd;
  end;
end;


end.
