(******************************************************************************
 * TACExtPanel                                                                *
 *                                                                            *
 * Data        Descrizione                                                    *
 * ----------- -------------------------------------------------------------- *
 * 29/12/2003  Prima Versione di questo pannello                              *
 *                                                                            *
 * 20/03/2004  Sono stati inserite delle chiamate per registrare un file di   *
 *             LOG                                                            *
 *                                                                            *
 ******************************************************************************)
unit AcExtPanel;

(******************************************************************************
 * Interface                                                                  *
 ******************************************************************************)
interface

{$i AcDefinizioni.pas }

(******************************************************************************
 * Uses                                                                       *
 ******************************************************************************)
uses
  Messages, Classes, Graphics, ExtCtrls, StdCtrls, Controls, ACTrStaticLabel,
  AcTransparentPanel, ACTrLabel{$ifdef AC_DEBUG_MODE} ,AC_Debug_Unit{$endif};


(******************************************************************************
 * Type                                                                       *
 ******************************************************************************)

type
  TACExtPanel = class(TPanel)
  private
    { Private declarations }
    f_Color_Start  : Tcolor;
    f_Color_End    : Tcolor;
    f_Color_Window : Tcolor;
    f_Color_Border : Tcolor;
    f_Color_Line   : Tcolor;
    Altezza        : Integer;
    F_Collapse     : Boolean; // True: Finestra ridotta
                              // False: Finestra non ridotta
    F_Titleheight  : Integer;
    Procedure Ridim;
  protected
    { Protected declarations }
//    cnt  : TPanel;
    lbl1 : TACTrLabel;
    lbl2 : TACTrLabel;
    Procedure Set_F_Color(Index:Integer;t:Tcolor);
    Procedure Disegna(Var msg:TMessage); message WM_PAint;
    Procedure Dimensione(Var msg:TMessage); message WM_SIZE;
    Procedure Set_TitleHeight(x:Integer);
    function Internal_Title_Height : Integer;
  public
    { Public declarations }
    Procedure Set_Collapse(x:Boolean);

    constructor Create(AOwner: TComponent); Override;
    destructor Destroy; Override;


  published
    { Published declarations }
    Property Align;
//    Property BorderWidth;
    Property Title_Height : Integer Read F_Titleheight Write Set_TitleHeight;
    property Color_Start : Tcolor Index 0 Read F_Color_Start Write Set_F_Color ;
    property Color_End : Tcolor Index 1 Read F_Color_End Write Set_F_Color ;
    property Color_Window : Tcolor Index 2 Read F_Color_Window Write Set_F_Color ;
    property Color_Border : Tcolor Index 3 Read F_Color_Border Write Set_F_Color ;
    property Color_Line   : Tcolor Index 4 Read F_Color_Line Write Set_F_Color ;
    Property Collapse     : Boolean Read F_Collapse Write Set_Collapse;
  end;

(******************************************************************************
 * Impelemtation                                                              *
 ******************************************************************************)
implementation

(******************************************************************************
 * Uses                                                                       *
 ******************************************************************************)
uses AcFunzioni_Grafiche, Forms, Windows, ACConst{$ifdef AC_DEBUG_MODE}, SysUtils{$endif};

(******************************************************************************
 * Costanti                                                                   *
 ******************************************************************************)
CONST RAGGIO=2;

(******************************************************************************
 * Disegna                                                                    *
 ******************************************************************************)
Procedure TACExtPanel.Disegna(Var msg:TMessage);
begin
  {$ifdef AC_DEBUG_MODE}
    if  not (csDesigning in ComponentState) then
    begin
        ac_debug_add_text('TACExtPanel: Disegna (ingresso)');
        ac_debug_add_text('             Nome componente: '+Self.Name);
    end;
  {$endif}

  inherited;


  Lbl1.Canvas.Pen.Style := psSolid;
  Lbl1.Canvas.Pen.color := Color_Border;
  Lbl1.Canvas.MoveTo(0,Lbl1.Height);
  Lbl1.Canvas.LineTo(0,RAGGIO);
  Lbl1.Canvas.LineTo(RAGGIO,0);
  Lbl1.Canvas.LineTo(Lbl1.Width-RAGGIO-1,0);
  Lbl1.Canvas.LineTo(Lbl1.Width-1,RAGGIO);
  Lbl1.Canvas.LineTo(Lbl1.Width-1,Lbl1.Height);

  Lbl1.Canvas.Brush.Style := bsSolid;
  Lbl1.Canvas.Brush.Color := Color;
  Lbl1.Canvas.FloodFill(1,0,Color_Border,fsBorder);
  Lbl1.Canvas.FloodFill(Lbl1.Width-1,0,Color_Border,fsBorder);
//   Lbl1.Canvas.pixels[lbl1.width-1,1] := 0;


  Lbl2.Canvas.Pen.Style := psSolid;
  Lbl2.Canvas.Pen.color := Color_Border;
  Lbl2.Canvas.Rectangle(0,0,Lbl2.Width,Lbl2.Height);


  Lbl2.Canvas.Pen.color := Color_Line;
  Lbl2.Canvas.MoveTo(0+1,0);
  Lbl2.Canvas.LineTo(Lbl2.Width-1,0);

  Lbl2.SendToBack;



end;
(******************************************************************************
 * constructor                                                                *
 ******************************************************************************)
constructor TACExtPanel.Create(AOwner: TComponent);
begin
  {$ifdef AC_DEBUG_MODE}
    if  not (csDesigning in ComponentState) then
    begin
        ac_debug_add_text('TACExtPanel: Create (ingresso)');
        ac_debug_add_text('             Nome componente: '+Self.Name);
    end;
  {$endif}

 inherited;
 Collapse      := False;
 BevelInner    := bvNone;
 BevelOuter    := bvNone;
 BorderStyle   := bsNone;


 lbl1          := TACTrLabel.Create(Self);
 lbl1.parent   := Self;

 lbl2          := TACTrLabel.Create(Self);
 lbl2.parent   := Self;

 Color_Start   := $00EEEEEE;
 Color_End     := $00F7DFD6;
 Color_Window  := $00F7DFD6;
 Color_Border  := clWhite;
 Color_Line    := $00F7D7C6;

 Borderwidth   := 5;


 Title_Height  := 25;
 ParentColor := True;

// lbl2.hide;
end;

(******************************************************************************
 * Destroy                                                                    *
 ******************************************************************************)
destructor TACExtPanel.Destroy;
begin
  {$ifdef AC_DEBUG_MODE}
    if  not (csDesigning in ComponentState) then
    begin
        ac_debug_add_text('TACExtPanel: Destroy (ingresso)');
        ac_debug_add_text('             Nome componente: '+Self.Name);
    end;
  {$endif}

 Lbl1.Free;
 Lbl2.Free;
 inherited;
end;

(******************************************************************************
 * Set_F_Color                                                                *
 ******************************************************************************)
Procedure TACExtPanel.Set_F_Color(Index:Integer;t:Tcolor);
begin
  {$ifdef AC_DEBUG_MODE}
    if  not (csDesigning in ComponentState) then
    begin
        ac_debug_add_text('TACExtPanel: Set_F_Colore (ingresso)');
        ac_debug_add_text('             Nome componente: '+Self.Name);
        ac_debug_add_text('             Index : '+IntToStr(Index));
        ac_debug_add_text('             T: '+IntToStr(t));
    end;
  {$endif}

// if(parent=nil) then exit;
 case index of
   0:
     begin
       f_Color_Start := t;
       lbl1.Color_Start := Color_Start;
     end;
   1:
     begin
       f_Color_End := t;
       lbl1.Color_End   := Color_End;
     end;
   2:
     begin
       f_Color_Window := t;
       lbl2.Color_Start := t;
       lbl2.Color_End := t;
     end;
   3:
       f_color_border := t;
   4:
       f_color_line := t;

 end;

 Invalidate;
end;


(******************************************************************************
 * Set_Collapse                                                               *
 ******************************************************************************)
Procedure TACExtPanel.Set_Collapse(X:Boolean);
Begin
  {$ifdef AC_DEBUG_MODE}
    if  not (csDesigning in ComponentState) then
    begin
        ac_debug_add_text('TACExtPanel: SetCollapse (ingresso)');
    end;
  {$endif}

  if (x) then
  begin
    Altezza := Height;
    Height := Lbl1.Height+Lbl1.Top+1;
    F_Collapse := X;

  end
  else
  begin
    if (Collapse) then Height := Altezza;
    F_Collapse := X;

  end;

End;

(******************************************************************************
 * Set_TitleHeight                                                            *
 ******************************************************************************)
Procedure TACExtPanel.Set_TitleHeight(x:Integer);
Begin
  f_titleheight := x;
//  invalidate;
  Ridim;
End;


(******************************************************************************
 * Dimensione                                                                 *
 ******************************************************************************)
Procedure TACExtPanel.Dimensione(Var msg:TMessage);
begin
  Ridim;
end;

(******************************************************************************
 * Ridim;                                                                     *
 ******************************************************************************)
Procedure TACExtPanel.Ridim;
begin
 lbl1.left         := borderwidth;
 lbl1.top          := borderwidth;
 lbl1.width        := width-borderwidth*2;
 lbl1.height       := Internal_Title_Height-lbl1.top;
 lbl1.Color_Start  := Color_Start;
 lbl1.Color_End    := Color_End;

 lbl2.left         := borderwidth;
 lbl2.top          := Internal_Title_Height;
 lbl2.width        := width-borderwidth*2;
 lbl2.height       := Height-Internal_Title_Height;
 lbl2.Color_Start  := Color_Window;
 lbl2.Color_End    := Color_Window;

end;

(******************************************************************************
 * Internal_Title_Height                                                      *
 ******************************************************************************)
Function TACExtPanel.Internal_Title_Height : integer;
Begin
  {$ifdef AC_DEBUG_MODE}
    if  not (csDesigning in ComponentState) then
    begin
        ac_debug_add_text('TACExtPanel: Internal_Title_Height(ingresso)');
        ac_debug_add_text('             Nome componente: '+Self.Name);
        ac_debug_add_text('             Title Height: '+IntToStr(Title_Height));
        ac_debug_add_text('             Screen.PixelsPerInch : '+IntToStr(Screen.PixelsPerInch));

    end;
  {$endif}

  Internal_Title_Height := Title_Height * Screen.PixelsPerInch div DPI_SCHERMOBASE;
end;

end.
