(******************************************************************************
 * ACAngLabel                                                                 *
 *                                                                            *
 * Domenica, 05/Agosto/2001                                                   *
 * -------------------------------------------------------------------------- *
 *         La classe non viene piu' ereditata ma "TCustomLabel", ma da        *
 *         "TACTrLabel" per fare in modo di avere lo sfondo con gradiente di  *
 *         colore variabile                                                   *
 *                                                                            *
 ******************************************************************************)
unit ACAngLabel;

(******************************************************************************
 * Interface                                                                  *
 ******************************************************************************)
interface

(******************************************************************************
 * Uses                                                                       *
 ******************************************************************************)
uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, ACTrLabel;

(******************************************************************************
 * Type                                                                       *
 ******************************************************************************)
type
  TACAngLabel = class(TACTrLabel)
  private
    { Private declarations }
  protected
    { Protected declarations }

    Mio_Angolo : Integer;
    Procedure Set_Angolo(x:Integer);
  public
    { Public declarations }
    constructor Create(AOwner: TComponent); override;
    procedure paint; override;
  published
    { Published declarations }
    Property Angle : Integer Read Mio_Angolo Write Set_Angolo;
    Property Font;
    Property Caption;
    Property AutoSize;
    property Transparent;
//    property Transparent;
  end;


(******************************************************************************
 * implementation                                                             *
 ******************************************************************************)
implementation

(******************************************************************************
 * Uses                                                                       *
 ******************************************************************************)
Uses AcVarie;


(******************************************************************************
 * constructor                                                                *
 ******************************************************************************)
constructor TACAngLabel.Create(AOwner: TComponent);
Begin
  Inherited;
  Font.Name := 'Arial';
  Angle := 45;
End;

(******************************************************************************
 * paint                                                                      *
 ******************************************************************************)
procedure TACAngLabel.paint;
var
 Fnt     : hFont;
 LogFont : TLogFont;
 F       : TFont;
 XX,
 YY      : Integer;
 Angolo  : Integer;
begin

  Angolo := Angle mod 360;

//  if not Transparent then
//  begin

//    Canvas.Brush.Color := Color;
//    Canvas.Brush.Style := bsSolid;
//    Canvas.FillRect(ClientRect);
//  end;
  Disegna_Fondo;
  FillChar(LogFont, SizeOf(LogFont), 0);
  With LogFont do
  Begin
    lfHeight      := -Font.Height;
    lfOrientation := 0;
    lfEscapement  := Angle*10;
    lfWeight      := FW_BOLD;
    lfCharSet     := OEM_CHARSET;
    StrPCopy(lfFaceName,Font.Name);
  End;
  Fnt := CreateFontIndirect(LogFont);
  F := TFont.Create;
  F.Color := Font.Color;
  F.Handle := Fnt;
  Canvas.Font := F;
  Canvas.Brush.Color := Color;

  Canvas.Brush.Style := bsClear;


//********** XX **********
//  Size1 := Round(Canvas.Textwidth(Caption)*Cos(Angle*3.14/180));
  if (Angolo<=90) then XX    := 0
  Else if (Angolo<=180) then XX    := Width-Round(Canvas.TextHeight(Caption)*Sin(Angolo*3.14/180))
  Else if (Angolo<=270) then XX    := Width+Round(Canvas.TextHeight(Caption)*Sin(Angolo*3.14/180))
  Else XX    := Canvas.Textheight(Caption);
//********** YY **********
  if (Angolo<=90) then yy := Height-Canvas.TextHeight(Caption)
  Else if (Angolo<=180) then yy := Height
  Else if (Angolo<=270) then yy := Canvas.TextHeight(Caption)
  Else yy := Canvas.TextHeight(Caption);


  Canvas.TextOut(XX, YY, Caption);

  F. Free;
  DeleteObject(Fnt);
End;

(******************************************************************************
 * Set_Angolo                                                                 *
 ******************************************************************************)
Procedure TACAngLabel.Set_Angolo(x:Integer);
Begin
  Mio_Angolo := x;
  Invalidate;
End;
end.

