{******************************************************************************
 * CopyFile                                                                   *
 ******************************************************************************}
unit ACCopy;

{******************************************************************************
 * interface                                                                  *
 ******************************************************************************}
 interface

{******************************************************************************
 * Uses                                                                       *
 ******************************************************************************}
 uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs;

{******************************************************************************
 * Type                                                                       *
 ******************************************************************************}
 type
  TACCopyFile = class(TComponent)
  private
    { Private declarations }
    FSource : String;
    FDest   : String;
  protected
    { Protected declarations }
    constructor Create(AOwner: TComponent); override;

  public
    { Public declarations }
    Function CopyFile:Integer;
  published
    { Published declarations }
    property SourceFile : string read FSource Write FSource;
    property DestinationFile : string read FDest Write FDest;
  end;

{******************************************************************************
 * Implementation                                                             *
 ******************************************************************************}
implementation

{******************************************************************************
 * Uses                                                                       *
 ******************************************************************************}
 uses lzExpand;



{******************************************************************************
 * Create                                                                     *
 ******************************************************************************}
constructor TACCopyFile.Create(AOwner: TComponent);
Begin
  Inherited;
  FSource := '';
  FDest   := '';
End;

{******************************************************************************
 * CopyFile                                                                   *
 ******************************************************************************}
Function TACCopyFile.CopyFile:Integer;
Var f_in,f_out : Integer;
    num        : Integer;
    buf        : TOFStruct;
Begin
  num := 0;
  try
    f_in := LZOpenFile(PChar(SourceFile+#0),buf,OF_READ);
    if (F_in>0) then
    Begin
      f_out := LZOpenFile(PChar(DestinationFile+#0),buf,OF_CREATE	);
      if (F_out>0) then
      begin
        Num := LzCopy(f_in,f_out);
        LzClose(f_Out);
      End;
      LzClose(f_In);
    end;
  except
  end;
  CopyFile := num;
End;

end.


