(******************************************************************************
 * AcDbLabel                                                                  *
 ******************************************************************************)
unit AcDbLabel;
{$i AcDefinizioni.pas }
(******************************************************************************
 * Interface                                                                  *
 ******************************************************************************)
 interface

(******************************************************************************
 * Uses                                                                       *
 ******************************************************************************)
uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, ACDbf
{$IFDEF DELPHI2}
   ,DsgnIntf
{$ENDIF}
{$IFDEF DELPHI6}
   ,DesignIntf,DesignEditors
{$ENDIF};


(******************************************************************************
 * Type                                                                       *
 ******************************************************************************)
type

  TACDBLabel = class(TLabel)
  private
    { Private declarations }
     Comp_TACDbf : TACDbf;
     Campo       : String;
  protected
    { Protected declarations }
    procedure Set_TACDbf(V:TACDbf);

  public
    { Public declarations }
    procedure Legge_Field;
    constructor Create(AOwner: TComponent);override;
    destructor Destroy;override;

  published
    { Published declarations }
    property FieldSource : TACDbf Read Comp_TACDbf Write Set_TACDbf;
    property FieldName   : String read Campo Write Campo;
  end;

(******************************************************************************
 * Implementation                                                             *
 ******************************************************************************)
implementation

(******************************************************************************
 * Constructor                                                                *
 ******************************************************************************)
constructor TACDBLabel.Create(AOwner: TComponent);
Begin
  Comp_TACDbf:=TACDbf.Create(Self);
  Inherited;
End;

(******************************************************************************
 * Destructor                                                                 *
 ******************************************************************************)
destructor TACDBLabel.Destroy;
Begin
  if (Comp_TACDbf<>Nil) then Comp_TACDbf.Remove_Control(Legge_Field);
//  Comp_TACDbf.Free;
  Inherited;
End;

(******************************************************************************
 * Set_TACDBF                                                                 *
 ******************************************************************************)
procedure TACDBLabel.Set_TACDbf(V:TACDbf);
Begin
  if (Comp_TACDbf<>nil) then
  begin
    if(Comp_TACDbf<>v) then Comp_TACDbf.Remove_Control(Legge_Field);
  end;
//  Comp_TACDbf.Assign(v);
  comp_TACDBF := v;
  Comp_TACDbf.Add_Control(Legge_Field);
End;


(******************************************************************************
 * Legge_Field                                                                *
 ******************************************************************************)
procedure TACDBLabel.Legge_Field;
Begin
  if (FieldSource<>nil) then
  Begin
    if (FieldName<>'') then
    begin
      Caption := FieldSource.Get_Field_Str(FieldName);
    end;
  End;
End;


end.
