(******************************************************************************
 * AcGraphicControl                                                           *
 ******************************************************************************)
unit AcGraphicControl;

(******************************************************************************
 * Interface                                                                  *
 ******************************************************************************)
interface

(******************************************************************************
 * Uses                                                                       *
 ******************************************************************************)
uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  QuickRep;

(******************************************************************************
 * TAcGraphicControl                                                          *
 ******************************************************************************)
type
  TAcGraphicControl = class(TQRCustomControl)
  private
    { Private declarations }
    FPen          : TPen;
    FBrush        : TBrush;

  protected
    { Protected declarations }
    procedure SetBrush(Value: TBrush);
    procedure SetPen(Value: TPen);
    procedure StyleChanged(Sender: TObject);
    property Brush: TBrush read FBrush write SetBrush;
    property Pen: TPen read FPen write SetPen;

  public
    { Public declarations }
    destructor Destroy; override;
    constructor Create(AOwner : TComponent); override;
  published
    { Published declarations }
  end;


(******************************************************************************
 * Implementation                                                             *
 ******************************************************************************)
implementation

(******************************************************************************
 * Constructor                                                                *
 ******************************************************************************)
constructor TAcGraphicControl.Create(AOwner : TComponent);
Begin
 AutoSize        := False;
 Inherited;
 FPen            := TPen.Create;
 FBrush          := TBrush.Create;
 FPen.OnChange   := StyleChanged;
 FBrush.OnChange := StyleChanged;

End;
(******************************************************************************
 * SetPen                                                                     *
 ******************************************************************************)
procedure TAcGraphicControl.SetPen(Value: TPen);
begin
  FPen.Assign(Value);
end;

(******************************************************************************
 * SetBrush                                                                   *
 ******************************************************************************)
procedure TAcGraphicControl.SetBrush(Value: TBrush);
begin
  FBrush.Assign(Value);
end;

(******************************************************************************
 * Destroy                                                                    *
 ******************************************************************************)
destructor TAcGraphicControl.Destroy;
Begin
 FPen.Free;
 FBrush.Free;

 Inherited;
End;

(******************************************************************************
 * StyleChanged                                                               *
 ******************************************************************************)
procedure TAcGraphicControl.StyleChanged(Sender: TObject);
begin
  Invalidate;
end;

end.
