(******************************************************************************
 * ACKeyState                                                                 *
 ******************************************************************************)
unit ACKeyState;

(******************************************************************************
 * interface                                                                  *
 ******************************************************************************)
interface

(******************************************************************************
 * Uses                                                                       *
 ******************************************************************************)
uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs;

(******************************************************************************
 * Type                                                                       *
 ******************************************************************************)
type
  TACKeyState = class(TComponent)
  private
    { Private declarations }
    Stato_Key             : TKeyboardState;
  protected
    { Protected declarations }
  public
    { Public declarations }
    function Get_Stato (Ndx : Integer) : Boolean;
    Procedure Set_Stato (Ndx : Integer;st:Boolean);
    Constructor Create(AOwner: TComponent); override;
  published
    { Published declarations }
    Property Scroll_Lock  : Boolean Index VK_SCROLL     Read Get_Stato Write Set_Stato Stored False;
//    Property L_Shift      : Boolean Index VK_LSHIFT     Read Get_Stato Write Set_Stato Stored False;
//    Property R_Shift      : Boolean Index VK_RSHIFT     Read Get_Stato Write Set_Stato Stored False;
//    Property L_Control    : Boolean Index VK_LCONTROL   Read Get_Stato Write Set_Stato Stored False;
//    Property R_Control    : Boolean Index VK_RCONTROL   Read Get_Stato Write Set_Stato Stored False;
//    Property L_Menu       : Boolean Index VK_LMENU      Read Get_Stato Write Set_Stato Stored False;
//    Property R_Menu       : Boolean Index VK_RMENU      Read Get_Stato Write Set_Stato Stored False;
    Property Num_Lock     : Boolean Index VK_NUMLOCK    Read Get_Stato Write Set_Stato Stored False;
    Property Caps_Lock    : Boolean Index VK_CAPITAL    Read Get_Stato Write Set_Stato Stored False;

  end;

(******************************************************************************
 * implementation                                                             *
 ******************************************************************************)
implementation


(******************************************************************************
 * Get_Stato                                                                  *
 ******************************************************************************)
function TACKeyState.Get_Stato (Ndx : Integer) : Boolean;
Begin
  GetKeyboardState(Stato_Key);
  Get_Stato := Stato_Key[Ndx]<>0;
End;

(******************************************************************************
 * Create                                                                     *
 ******************************************************************************)
Constructor TACKeyState.Create(AOwner: TComponent); 
Begin
  Inherited;
End;
(******************************************************************************
 * Set_Stato                                                                  *
 ******************************************************************************)
Procedure TACKeyState.Set_Stato (Ndx : Integer;st:Boolean);
Begin
  GetKeyboardState(Stato_Key);
  if (st) then
    Stato_Key[Ndx] := 1
  else
    Stato_Key[Ndx] := 0;
  SetKeyboardState(Stato_Key);
End;

End.
