{******************************************************************************
 * OutBox                                                                     *
 *                                                                            *
 * Domenica, 10/01/1999                                                       *
 *         Quando si imposta "Disposizione" = Nessuna, la barra viene         *
 *         nascosta anche a Design-Time.                                      *
 *                                                                            *
 * Domenica, 29,08/1999                                                       *
 *         E' Stato aggiunto l'evento "OnBeforeResize" che viene chiamato     *
 *         prima che i pannelli dell'oggetto vengano ridimensionati           *
 *                                                                            *
 ******************************************************************************}
unit acOutBox;

{******************************************************************************
 * Interface                                                                  *
 ******************************************************************************}
 interface

{******************************************************************************
 * Uses                                                                       *
 ******************************************************************************}
 uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  ExtCtrls;

{******************************************************************************
 * Costanti                                                                   *
 ******************************************************************************}
 const SPESSORE_LINEA = 4;
{******************************************************************************
 * Type                                                                       *
 ******************************************************************************}
 type
  PListaPagina = ^ListaPagina;
  PDisposizione = (Verticale,Orizzontale,Nessuna);
  TProcedureChangePage = Procedure (Sender: TObject;Pagina:integer) of object;
  TProcedureResizePage = Procedure (Sender: TObject;larg1,largh2:integer) of object;
  ListaPagina = record
    Sh    : TImage;
    Next  : PListaPagina;
    num   : Integer;       // Numero pagina;
  end;
  TACOutBox = class(TPanel)
  private

    Linea              : Tpanel;     // Pannello di ridimensionamento
    PosizioneLinea     : Integer;    // Posizione della linea
    Fl_Drag            : Boolean;
    Elenco             : PListaPagina;

    Bordo              : TShape;
//    Obj              : TComponent;
    PaginaAttiva       : integer;
    NumeroPagine       : integer;
    ProceduraCambioPag : TProcedureChangePage;
    ProceduraResizePag : TProcedureResizePage;
    ProceduraBeforeRes : TNotifyEvent;
    LARGHEZZA_PAG      : integer;
    ALTEZZA_PAG        : integer;
    FDisp              : PDisposizione;
    in_paint           : Boolean; (* True: Sta ridisegnando il form *)
                             (* False: Non sta ridisegnando    *)

    { Private declarations }
  protected
    { Protected declarations }
//    procedure Change; dynamic;
    Procedure Libera(p:PListaPagina);
    Procedure Set_Color_scr1(Cl:TColor);
    Procedure Set_Color_scr2(Cl:TColor);
    Procedure Paint; override;
    procedure set_page(num:integer);
    procedure LineaMousedown(Sender: TObject; Button: TMouseButton;
                           Shift: TShiftState; X, Y: Integer);
    procedure LineaMouseUp(Sender: TObject; Button: TMouseButton;
                           Shift: TShiftState; X, Y: Integer);
    procedure LineaMouseMove(Sender: TObject; Shift: TShiftState; X,
                           Y: Integer);
    procedure ShapeMouseDown(Sender: TObject; Button: TMouseButton;
                           Shift: TShiftState; X, Y: Integer);
    procedure set_altezza_pag(num:integer);
    procedure set_larghezza_pag(num:integer);
    procedure set_disp(d:PDisposizione);
    procedure PaintVerticale;
    procedure PaintOrizzontale;
    procedure set_Sx(x:integer);
    Procedure Setta_Dimensione_Pagina(Larghezza,Altezza:Integer);
    Procedure Set_Stato_Comp(dis:PDisposizione);
    Function  Get_Color_scr1:TColor;
    Function  Get_Color_scr2:TColor;
  public
    Scr1  : TScrollBox; // Pannello di destra
    Scr2  : TScrollBox;
//    FList : TList;
    constructor Create(AOwner: TComponent); override;
    destructor Destroy; override;
    Procedure AddPagina(pic:TPicture);
    Procedure RemovePagina(num:integer);
    Procedure Set_Pag_Hint (Hint:String;Pagina:Integer);
    { Public declarations }
  published
    { Published declarations }
    property OnBeforeResize  : TNotifyEvent         read ProceduraBeforeRes Write ProceduraBeforeRes;
    property OnChangePage    : TProcedureChangePage read ProceduraCambioPag write ProceduraCambioPag;
    property OnResize        : TProcedureResizePage read ProceduraResizePag Write ProceduraResizePag;
    property CurrentPage     : integer              read PaginaAttiva       write set_page;
    property PaginaLarghezza : integer              read LARGHEZZA_PAG      write set_larghezza_pag default 66;
    property PaginaAltezza   : integer              read ALTEZZA_PAG        write set_altezza_pag default 92;
    property Disposizione    : PDisposizione        read FDisp              write set_disp;
    property Dimensione_Sx   : Integer              read PosizioneLinea     write set_sx;
    property Color_Scr1      : TColor               Read Get_Color_scr1     write Set_Color_scr1;
    property Color_Scr2      : TColor               Read Get_Color_scr2     write Set_Color_scr2;
  end;

{******************************************************************************
 * Implementation                                                             *
 ******************************************************************************}
 implementation


{******************************************************************************
 * Costruttore                                                                *
 ******************************************************************************}
constructor TACOutBox.Create(AOwner: TComponent);
begin
 Inherited;
// obj:=AOwner;
// FList             := TList.Create;
 PosizioneLinea    := 100;
 ctl3d             := False;
 borderstyle       := bsNone;
 Align             := alClient;
 ParentColor       := True;
 Elenco            := Nil;
 Fl_Drag           := False;
 CurrentPage       := -1;
 NumeroPagine      := 0;
 PaginaLarghezza   := 66;
 PaginaAltezza     := 93;
// ControlStyle      := ControlStyle - [csAcceptsControls];


//********** Pannello di sinistra **********
 scr1              := TScrollBox.Create(Self);
 scr1.BorderStyle  := bsNone;
 scr1.ctl3d        := false;
 scr1.parent       := Self;
 scr1.ParentColor  := False;
 scr1.align        := alLeft;
 scr1.visible      := true;
 Color_Scr1        := clAppWorkSpace;
// scr1.Color        := clAppWorkSpace;

//********** Pannello di destra **********
 scr2              := TScrollBox.Create(Self);
 scr2.BorderStyle  := bsNone;
 scr2.ctl3d        := False;
 scr2.parent       := Self;
 scr2.ParentColor  := False;
 scr2.align        := alRight;
 scr2.visible      := true;
 Color_Scr2        := clAppWorkSpace;
// scr2.Color        := clAppWorkSpace;
// FList.Add(Scr2);
//********** Bordo di delimitazione della pagina selezionata **********
 Bordo              := TShape.Create(Self);
 Bordo.parent       := scr1;
 Bordo.Pen.Color    := clRed;
 Bordo.left         := -2;
 Bordo.top          := -2;
 Bordo.Width        := 0;
 Bordo.Height       := 0;

// All'inizio non ci sono pagine attive e nasconde il bordo
 Bordo.Visible      := False;


 Linea             := TPanel.Create(Self);
 Linea.OnMouseDown := LineaMousedown;
 Linea.OnMouseUp   := LineaMouseUp;
 Linea.OnMouseMove := LineaMouseMove;
 Linea.Parent      := Self;
 Linea.caption     := '';
 Linea.visible     := true;

 Disposizione      := Verticale;

 OnChangePage      := Nil;
 OnResize          := Nil;
 OnBeforeResize    := Nil;


 in_paint          := False;

// change;
end;


{******************************************************************************
 * Distruttore                                                                *
 ******************************************************************************}
 destructor TACOutBox.Destroy;
var App1,App2 : PListaPagina;
//    c1        : Integer;
Begin
// Elimina l'elenco delle pagine
 App1 := Elenco;
 if(App1<>nil) then
 begin
   while(App1<>nil) do
   Begin
     app2:=app1^.Next;
     libera(app1);
     app1:=app2;
   end;
 end;
// Libera gli oggetti creati
// for c1 := 0 to FList.Count - 1 do FList.Remove(FList[C1]);
// for c1 := 0 to FList.Count - 1 do TPanel(FList[C1]) := nil;
 scr1.Free;
 scr2.Free;
 Linea.Free;
// FList.Free;
 Inherited;
End;
{******************************************************************************
 * PaintVerticale                                                             *
 *                                                                            *
 * Mette i due pannelli in verticale, uno a destra e uno a sinistra           *
 ******************************************************************************}
procedure TACOutBox.PaintVerticale;
Var App1 : PListaPagina;
    x,y  : integer;        // Posizione del disegno
    num  : integer;        // numero disegni per riga inseriti

Begin
// Imposta le dimensioni dei pannelli e la loro posizione
   scr1.width    := PosizioneLinea;
   scr2.width    := width - PosizioneLinea - Linea.width;
   Linea.width   := SPESSORE_LINEA;
   Linea.Height  := Height;
   Linea.top     := 0;
   Linea.Left    := PosizioneLinea;
   Linea.Visible := True;
//   Linea.Cursor := crSizeWE;

   num          := 0; // Azzera il numero di pagine presentio nella riga corrente
   x            := 10;
   y            := 10-Scr1.VertScrollBar.Position;
   app1 := Elenco;

// Posizione le icone delle immagini dell'elenco pagine
   While (app1<>nil) do
   begin

// Nel caso in cui ci sia ancora spazio per inserire un immagine oppure se non
// ci sono immagini (deve essercene presente almeno una per riga)
     if ( x + app1^.Sh.Width < scr1.ClientWidth)or(num=0) Then //Flag:=true
     else

// In caso in cui non ci sia spazio per inserire una nuova immagine
// la inserisce in una nuova riga
     begin
       x      := 10;
       y      := y + app1^.Sh.Height + 10;
       num    := 0;
     end;
     Num  := Num + 1;
     app1^.Sh.Left := x;
     app1^.Sh.Top  := y;
     x := x + app1^.Sh.Width + 10;
     //else y := y + PaginaAltezza + 10;
     App1:=App1^.Next;
   end;
end;
{******************************************************************************
 * PaintOrizzontale                                                           *
 ******************************************************************************}
procedure TACOutBox.PaintOrizzontale;
Var App1 : PListaPagina;
    x,y  : integer;        // Posizione del disegno
Begin
// Imposta la dimensione dei pannelli e la loro posizione
   scr1.height   := PosizioneLinea;
   scr2.height   := height - PosizioneLinea - Linea.Height;
   Linea.height  := SPESSORE_LINEA;
   Linea.Width   := Width;
   Linea.Left    := 0;
   Linea.Top     := PosizioneLinea;
   Linea.Visible := True;
//   Linea.Cursor := crSizeNS;
   x            := 10-Scr1.HorzScrollBar.Position;
   y            := 10;
   app1 := Elenco;

// Posoziona le icone sulla prima riga in alto
   While (app1<>nil) do
   begin
//     x      := 10;
//     y      := y + PaginaLarghezza + 10;

     app1^.Sh.Left := x;
     app1^.Sh.Top  := y;
     x := x + PaginaLarghezza + 10;
     App1:=App1^.Next;
   end;
end;

{******************************************************************************
 * Paint                                                                      *
 ******************************************************************************}
Procedure TACOutBox.paint;
Begin
 Inherited;
 in_paint := True;
 if (not fl_drag) then
 begin
   if(Disposizione=verticale) then paintverticale
   else if(Disposizione=orizzontale) then PaintOrizzontale;
   CurrentPage:=CurrentPage;
 end;
 in_paint := False;

end;

{******************************************************************************
 * LineaMousedown                                                             *
 *                                                                            *
 * Incomincia il drag della linea di separazione                              *
 ******************************************************************************}
procedure TACOutBox.LineaMousedown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
begin
 fl_drag:=true;
end;
{******************************************************************************
 * LineaMouseUp                                                               *
 *                                                                            *
 * Alla fine del drag ridimensiona i pannelli                                 *
 ******************************************************************************}
procedure TACOutBox.LineaMouseUp(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
Begin
 fl_drag:=false;
 x:=x+Linea.left;
 y:=y+linea.top;
 if(disposizione=verticale) then dimensione_sx := x;
 if(disposizione=orizzontale) then dimensione_sx := y;
End;
{******************************************************************************
 * LineaMouseMove                                                             *
 *                                                                            *
 * Se in Drag durante lo spostamento muove anche la linea                     *
 ******************************************************************************}
procedure TACOutBox.LineaMouseMove(Sender: TObject; Shift: TShiftState; X,
      Y: Integer);
Begin
 if (fl_drag) then
 begin
   if(Disposizione=verticale) then
   begin
     x:=x+Linea.left;
     PosizioneLinea:=x;
     Linea.left:=x;
   end
   else
   begin
     y:=y+Linea.top;
     PosizioneLinea:=y;
     Linea.top:=y;
   end
 end;
End;

{******************************************************************************
 * ShapeMouseDown                                                             *
 *                                                                            *
 * Se si clicca su un "Shape" si posiziona sulla pagina corrente              *
 ******************************************************************************}
procedure TACOutBox.ShapeMouseDown(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
var app : PListaPagina;
begin
 app := elenco;
 while(app<>nil) do
 begin
  if((app^.sh.left=TImage(Sender).left)and(app^.sh.top=TImage(Sender).top)) then
  begin
    CurrentPage:=app^.num;
  end;
  app:=app^.Next;
 end;
end;

{******************************************************************************
 * AddPagina                                                                  *
 *                                                                            *
 * Aggiunge una pagina all'elenco                                             *
 *                                                                            *
 * Nome      Descrizione                                                      *
 * --------- ---------------------------------------------------------------- *
 * Pic       Immagine da inserire per la pagina                               *
 ******************************************************************************}
Procedure TACOutBox.AddPagina(pic:TPicture);
var App1,App2 : PListaPagina;
Begin
 App1 := Elenco;
 if(App1<>nil) then
 begin
   while(App1.Next<>nil) do App1:=App1.Next;
 end;
 New(app2);
 inc(NumeroPagine);
 app2^.sh             := TImage.Create(Self);
 app2^.sh.Parent      := scr1;
 app2^.sh.Height      := PaginaAltezza;
 app2^.sh.Width       := PaginaLarghezza;
 app2^.sh.OnMouseDown := ShapeMouseDown;
 app2^.sh.Picture     := pic;
 app2^.num            := NumeroPagine;
 app2^.Next           := Nil;
 if(elenco=nil) then elenco:=app2
 else app1^.Next := app2;
 if(numeropagine=1) then CurrentPage:=1;
 Invalidate;
End;
{******************************************************************************
 * RemovePagina                                                               *
 *                                                                            *
 * Nome      Descrizione                                                      *
 * --------- ---------------------------------------------------------------- *
 * Num       Numero della pagina da rimuovere                                 *
 ******************************************************************************}
Procedure TACOutBox.RemovePagina(num:integer);
var App1,successivo : PListaPagina;
    Tolto           : Boolean;  {* True: Pagina eliminata *}
                                {* False: Pagina non elminata *}
Begin
 Tolto := False;
 if(numeroPagine=0) then
 begin
   exit;
 end;
 if(elenco^.num=num) then
 begin
   app1:=elenco;
   elenco:=Elenco^.Next;
   dec(NumeroPagine);
   tolto:=true;
   Libera(app1);
 end
 else
 begin
   app1:=Elenco;
   while (app1^.Next <> nil) do
   begin
     successivo:=app1^.Next;
     if(successivo^.num=num) then
     begin
       app1^.Next:=successivo^.Next;
       libera(successivo);
       dec(NumeroPagine);
       Tolto := True;
     end;
     app1:=app1^.next;
     if(app1=nil) then break;
   end;
 end;
 if (Tolto) Then
 begin
   app1:=Elenco;  // Rinumera
   while(app1<>nil) do
   begin
     if(app1^.num>=num) then dec(app1^.num);
     app1:=app1^.next;
   end;
   CurrentPage:=NumeroPagine;
   Invalidate;
 end;
End;
{******************************************************************************
 * Libera                                                                     *
 ******************************************************************************}
Procedure TACOutBox.Libera(p:PListaPagina);
Begin
   p^.sh.Free;
   dispose(p);
end;

{******************************************************************************
 * set_page                                                                   *
 *                                                                            *
 * Nome      Descrizione                                                      *
 * --------- ---------------------------------------------------------------- *
 * Num       Numero della pagina da impostare                                 *
 ******************************************************************************}
procedure TACOutBox.set_page(num:integer);
var app1 : PListaPagina;
begin
 app1:=elenco;
 PaginaAttiva:=num;
 if(Disposizione=Nessuna) then
 begin
   bordo.visible:=false;
   if assigned(OnChangePage) and (not in_paint) then OnChangePage(Self,CurrentPage);
   exit;
 end
 else
 while(app1<>nil) do
 begin
   if (app1^.num=num) then
   begin
     Bordo.Left:=app1^.sh.left-2;
     Bordo.top:=app1^.sh.top-2;
     Bordo.width:=app1^.sh.width+4;
     Bordo.height:=app1^.sh.height+4;
     Bordo.visible:=true;
     scr1.ScrollInView(Bordo);
     if assigned(OnChangePage) then OnChangePage(Self,CurrentPage);
     exit;
   end;
   app1:=app1^.Next;
 end;
end;

{******************************************************************************
 * set_larghezza_pag                                                          *
 ******************************************************************************}
procedure TACOutBox.set_larghezza_pag(num:integer);
begin
  if(num<1) then num := 3;
  LARGHEZZA_PAG:=num;
  Setta_Dimensione_Pagina(PaginaLarghezza,PaginaAltezza);
  invalidate;

end;
{******************************************************************************
 * set_altezza_pag                                                            *
 ******************************************************************************}
procedure TACOutBox.set_altezza_pag(num:integer);
begin
  if(num<1) then num := 3;
  ALTEZZA_PAG:=num;
  Setta_Dimensione_Pagina(PaginaLarghezza,PaginaAltezza);
  invalidate;
end;

{******************************************************************************
 * set_disp                                                                   *
 ******************************************************************************}
procedure TACOutBox.set_disp(d:PDisposizione);
begin
  if(Assigned(OnBeforeResize)) then OnBeforeResize(Self);
  FDisp:=d;
  Set_Stato_Comp(d);
  invalidate;
  if(Assigned(OnResize)) then OnResize(Self,scr1.width,scr2.width);
end;

{******************************************************************************
 * set_Sx                                                                     *
 ******************************************************************************}
 procedure TACOutBox.set_Sx(x:integer);
 begin
  if(Assigned(OnBeforeResize)) then OnBeforeResize(Self);
  PosizioneLinea:=x;
  if(disposizione=verticale) then
  begin
    Linea.Left:=x;
    scr1.width:=x-2;
    scr2.width:=(Width-x-2-2);
  end
  else
  begin
    Linea.top:=x;
    scr1.height:=x-2;
    scr2.height:=(Height-x-2-2);

  end;
  invalidate;
  if(Assigned(OnResize)) then OnResize(Self,scr1.width,scr2.width);
 end;


{******************************************************************************
 * SetHint                                                                    *
 *                                                                            *
 * Nome       Descrizione                                                     *
 * ---------- --------------------------------------------------------------- *
 * Hint       Hint da inserire nella pagina                                   *
 * Pagina     Pagina in cui inserire l'Hint                                   *
 ******************************************************************************}
Procedure TACOutBox.Set_Pag_Hint(Hint:String;Pagina:Integer);
var App1 : PListaPagina;
Begin
 App1 := Elenco;
 if(App1<>nil) then
 begin
// Cerca la pagina
   while(App1<>nil) do
   Begin
     if(App1^.Num=Pagina) then
     Begin
// Trovata la pagina setta l'Hint
       if(Hint='') Then
       Begin
         App1.sh.ShowHint := False;
         exit;
       End
       Else
       Begin
         App1.Sh.Hint := Hint;
         App1.Sh.ShowHint := True;
         exit;
       End;
     End;
     App1:=App1^.Next;
   end;
 end;
End;


{******************************************************************************
 * SetHint
 ******************************************************************************}
Procedure TACOutBox.Setta_Dimensione_Pagina(Larghezza,Altezza:Integer);
var App1 : PListaPagina;
Begin
 App1 := Elenco;
 if(App1<>nil) then
 begin
   while(App1<>nil) do
   Begin
     App1.Sh.Width  := Larghezza;
     App1.Sh.Height := Altezza;
     App1           := App1^.Next;
   end;
 end;
End;

//procedure TACOutBox.Change;
//var
//  Form: TForm;
//begin
//  UpdateActivePage;
//  if csDesigning in ComponentState then
//  begin
//    Form := GetParentForm(Self);
//    if (Form <> nil) and (Form.Designer <> nil) then Form.Designer.Modified;
//  end;
//  inherited ;
//end;
{******************************************************************************
 * Set_Stato_Comp                                                             *
 ******************************************************************************}
Procedure TACOutBox.Set_Stato_Comp(dis:PDisposizione);
Begin
  if(Dis=verticale) then
  begin
    scr1.visible      := true;
    scr2.visible      := true;
    linea.visible     := true;
    linea.cursor      := CrHSplit;
    scr1.align        := alLeft;
    scr2.align        := alRight;
    //Linea.Align       := alLeft;
  end
  else if (Dis=orizzontale) then
  begin
    scr1.visible      := true;
    scr2.visible      := true;
    linea.visible     := true;
    linea.cursor      := CrVSplit;
    scr1.align        := alTop;
    scr2.align        := alBottom;
    //Linea.Align       := alTop;
  end
  else
  begin
    scr1.visible      := false;
    linea.visible     := false;
    scr2.visible      := true;
    scr2.align        := alClient;
    Linea.Top         := 0;
    Linea.Left        := 0;
    Linea.Width       := 0;
    Linea.Height      := 0;
    //Linea.Align       := alNone;
  end;

End;

{******************************************************************************
 * Set_Color_scr1                                                             *
 ******************************************************************************}
Procedure TACOutBox.Set_Color_scr1(Cl:TColor);
Begin
  scr1.Color := Cl;
End;

{******************************************************************************
 * Set_Color_scr2                                                             *
 ******************************************************************************}
Procedure TACOutBox.Set_Color_scr2(Cl:TColor);
Begin
  scr2.Color := Cl;
End;

{******************************************************************************
 * Get_Color_scr1                                                             *
 ******************************************************************************}
Function TACOutBox.Get_Color_scr1:TColor;
Begin
  Get_Color_scr1 := scr1.Color;
End;

{******************************************************************************
 * Get_Color_scr2                                                             *
 ******************************************************************************}
Function TACOutBox.Get_Color_scr2:TColor;
Begin
  Get_Color_scr2 := scr2.Color;
End;

end.
