(******************************************************************************
 * TACRegistry                                                                *
 *                                                                            *
 * Modifiche                                                                  *
 *                                                                            *
 * Domenica, 06/09/1998                                                       *
 *           Aggiunta della funzione "DeleteCurentKey"                        *
 * Gioved, 25/02/1999                                                        *
 *          Sono stati aggiunti i metodi                                      *
 *           "Get_KeyName_List"                                               *
 *           "Get_ValueName_List"                                             *
 *          Per ottenere l'elenco delle chiavi e dei valori nella posizione   *
 *          corrente del registro.                                            *
 ******************************************************************************)
unit AcRegistry;
{$i AcDefinizioni.pas }
(******************************************************************************
 * interface                                                                  *
 ******************************************************************************)
 interface

(******************************************************************************
 * uses                                                                       *
 ******************************************************************************)
 uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms,
  Dialogs, AcProcDeclare
{$IFDEF DELPHI2}
  ,DsgnIntf
{$ENDIF}
{$IFDEF DELPHI6}
  ,DesignIntf, DesignEditors
{$ENDIF};

(******************************************************************************
 * type                                                                       *
 ******************************************************************************)
type
  TACRegSet=(HKEY_CLASSES_ROOT,
             HKEY_CURRENT_USER,
             HKEY_LOCAL_MACHINE,
             HKEY_USERS,
             HKEY_PERFORMANCE_DATA,
             HKEY_CURRENT_CONFIG,
             HKEY_DYN_DATA);
  TACRegistryString = class(TComponent)
  private
    { Private declarations }
    FRoot    : TACRegSet;        // Parametro
    FKeyName      : String;
    FValueName    : String;
    FStrValue     : String;
  protected
    { Protected declarations }
      WriteEnabled : Boolean;
//    procedure split(txt:string;var txt1,txt2,txt3,txt4,txt5:string);
      procedure setStrValue(txt:String);
      function  getStrValue:string;
      procedure setRoot(v1:TACRegSet);
      procedure setKey(txt:String);
  public
    { Public declarations }
      constructor Create(AOWner:TComponent);override;
      Function DeleteCurrentKey : Boolean;
      Procedure Get_KeyName_List (Txt:TStrings);
      Procedure Get_ValueName_List (Txt:TStrings);
  published
    { Published declarations }

    property Root : TACRegSet read FRoot Write SetRoot;
    property StrValue : String read getStrValue Write setStrValue;
    property KeyName : String read FKeyName Write setKey;
    property ValueName   : String read FValueName Write FValueName;
  end;


(******************************************************************************
 * TAccKeyEditProperty                                                        *
 ******************************************************************************)
{$IFDEF DELPHI2}
 type TAcKeyEditProperty = Class(TStringProperty)
{$ENDIF}
{$IFDEF DELPHI6}
 type TAcKeyEditProperty = Class(TPropertyEditor)
{$ENDIF}
 public
   function GetAttributes : TPropertyAttributes; override;
   procedure GetValues(Proc: TGetStrProc);override;
 end;

(******************************************************************************
 * TAccValueKeyEditProperty                                                   *
 ******************************************************************************)
type TAcValueEditProperty = Class(TAcKeyEditProperty)
 public
   procedure GetValues(Proc: TGetStrProc);override;
 end;


(******************************************************************************
 * implementation                                                             *
 ******************************************************************************)
implementation

(******************************************************************************
 * uses                                                                       *
 ******************************************************************************)
 uses Registry;

 (******************************************************************************
 * Funzioni interne                                                           *
 ******************************************************************************)
function get_int_Root (Root : TACRegSet):Integer; forward;

(******************************************************************************
 * setStrValue                                                                *
 ******************************************************************************)
procedure TACRegistryString.setStrValue(txt:String);
var  intRoot   : Integer;
     TReg      : TRegistry;
begin
 if (WriteEnabled=False) then exit;
 IntRoot := get_int_Root(Root);
 TReg := Nil;
 try
   TReg := TRegistry.create;
   TReg.RootKey := intRoot;
   if TReg.openkey(KeyName,True) then
   begin
     TReg.WriteString(ValueName,Txt);
   end;
 Finally
   if(TReg<>Nil) then TReg.free;
 end;
end;

(******************************************************************************
 * getStrValue                                                                *
 ******************************************************************************)
function TACRegistryString.getStrValue:string;
var  intRoot   : Integer;
     txt       : String;
     TReg      : TRegistry;
begin
 Txt:='';
 IntRoot := get_int_Root(Root);
 TReg := Nil;
 try
   TReg := TRegistry.create;
   TReg.RootKey := intRoot;
   if TReg.openkey(KeyName,False) then
   begin
     txt:=TReg.ReadString(ValueName);
   end;
 finally
   if(TReg<>Nil) then TReg.free;
 end;
 GetStrValue:=txt;
end;
(******************************************************************************
 * setRoot                                                                    *
 ******************************************************************************)
procedure TACRegistryString.setRoot(v1:TACRegSet);
Begin
 WriteEnabled:=False;
 FRoot:=v1;
 KeyName :='';
 ValueName :='';
 StrValue :='';
 WriteEnabled:=True;
End;

(******************************************************************************
 * setRoot                                                                    *
 ******************************************************************************)
procedure TACRegistryString.setKey(txt:String);
Begin
 WriteEnabled := False;
 FKeyName     := txt;
 ValueName    := '';
 StrValue     := '';
 WriteEnabled := True;
End;

(******************************************************************************
 * GetAttributes                                                              *
 ******************************************************************************)
function TAcKeyEditProperty.GetAttributes : TPropertyAttributes;
begin
  Result:=inherited GetAttributes+[paValueList, paDialog, paMultiSelect];
end;

(******************************************************************************
 * GetValues                                                                  *
 ******************************************************************************)
//procedure TAcKeyEditProperty.Edit;
procedure TAcValueEditProperty.GetValues(Proc: TGetStrProc);
Var Root    : TACRegSet;
    IntRoot : Integer;
    List    : TStringList;
    TReg    : TRegistry;
    c1      : Integer;
    base    : String;
begin
  Root := (GetComponent(0) as TACRegistryString).Root;
  Base := (GetComponent(0) as TACRegistryString).KeyName;
  IntRoot := get_int_Root(Root);
  List := Nil;
  TReg := Nil;
  try
    list := TStringList.Create;
    TReg := TRegistry.create;
    TReg.RootKey:=IntRoot;
    TReg.openkey(Base,false);
    TReg.GetValueNames(List);
    for c1 := 0 to list.count-1 do
      proc(List.Strings[c1]);

  finally
    if(List<>Nil) then list.free;
    if(TReg<>Nil) then TReg.Free;
  end;
end;

(******************************************************************************
 * Create                                                                     *
 ******************************************************************************)
constructor TACRegistryString.Create(AOWner:TComponent);
Begin
  Inherited;
  WriteEnabled := True;
  Root         := HKEY_CLASSES_ROOT;
End;

(******************************************************************************
 * Edit                                                                       *
 ******************************************************************************)
//procedure TAcKeyEditProperty.Edit;
procedure TAcKeyEditProperty.GetValues(Proc: TGetStrProc);
Var Root    : TACRegSet;
    IntRoot : Integer;
    List    : TStringList;
    TReg    : TRegistry;
    c1      : Integer;
    base    : String;
begin
  List := Nil;
  TReg := Nil;
  try
    list := TStringList.Create;
    TReg := TRegistry.create;
    Root := (GetComponent(0) as TACRegistryString).Root;
    Base := (GetComponent(0) as TACRegistryString).KeyName;
    IntRoot := get_int_Root(Root);
    TReg.RootKey:=IntRoot;
    TReg.openkey(Base,false);
    TReg.GetKeyNames(List);
    for c1 := 0 to list.count-1 do
      proc(Base+'\'+List.Strings[c1]);
  finally
    if(List<>Nil) then list.free;
    if(TReg<>Nil) then TReg.Free;
  end;
end;

(******************************************************************************
 * Edit                                                                       *
 *                                                                            *
 * Ritorna:                                                                   *
 *   True: Cancellazione riuscita                                             *
 *   False: Cancellazione non riuscita                                        *
 ******************************************************************************)
Function TACRegistryString.DeleteCurrentKey : Boolean;
var  intRoot   : Integer;
     TReg      : TRegistry;
begin
 DeleteCurrentKey := False;
 if (WriteEnabled=False) then exit;
 IntRoot := get_int_Root(Root);
 TReg := Nil;
 try
   TReg := TRegistry.create;
   TReg.RootKey := intRoot;
   DeleteCurrentKey := TReg.DeleteKey(KeyName);
 Finally
   if(TReg<>Nil) then TReg.free;
 end;


End;

(******************************************************************************
 * Get_KeyName_List                                                           *
 ******************************************************************************)
Procedure TACRegistryString.Get_KeyName_List (Txt:TStrings);
var
     TReg      : TRegistry;
Begin
 TReg         := Nil;
 Txt.Clear;
 try
   TReg         := TRegistry.create;
   TReg.RootKey := get_int_Root(Root);
   if TReg.openkey(KeyName,False) then
   begin
     TReg.GetKeyNames(Txt);
   end;
 finally
   if(TReg<>Nil) then TReg.free;
 end;
End;

(******************************************************************************
 * Get_ValueName_List                                                         *
 ******************************************************************************)
Procedure TACRegistryString.Get_ValueName_List (Txt:TStrings);
var
     TReg      : TRegistry;
Begin
 TReg         := Nil;
 Txt.Clear;
 try
   TReg         := TRegistry.create;
   TReg.RootKey := get_int_Root(Root);
   if TReg.openkey(KeyName,False) then
   begin
     TReg.GetValueNames(Txt);
   end;
 finally
   if(TReg<>Nil) then TReg.free;
 end;
End;

(******************************************************************************
 * get_int_Root                                                               *
 ******************************************************************************)
function get_int_Root (Root : TACRegSet):Integer;
Var
{$IFDEF DELPHI2}
    IntRoot : Integer;
{$ENDIF}
{$IFDEF DELPHI6}
    IntRoot : Longword;
{$ENDIF}

Begin
 IntRoot := $80000000;
 if (Root = HKEY_CLASSES_ROOT)     then IntRoot := $80000000;
 if (Root = HKEY_CURRENT_USER)     then IntRoot := $80000001;
 if (Root = HKEY_LOCAL_MACHINE)    then IntRoot := $80000002;
 if (Root = HKEY_USERS)            then IntRoot := $80000003;
 if (Root = HKEY_PERFORMANCE_DATA) then IntRoot := $80000004;
 if (Root = HKEY_CURRENT_CONFIG)   then IntRoot := $80000005;
 if (Root = HKEY_DYN_DATA)         then IntRoot := $80000006;
 Get_Int_Root := IntRoot;
End;

end.
