unit AcTreeDir;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  ComCtrls, ExtCtrls;

type
  TACTreeDir = class(TCustomTreeView)
  private
    { Private declarations }
    ImgLst : TImageList;
    Img1,
    Img2   : TBitMap;
    Percorso : String;  // Perorso base
  protected
    { Protected declarations }
    Procedure Set_Percorso(Txt:String);
    function completa_percorso(txt:String):String;
    Function agg(Nome,Completo:String;Nodo:TTreeNode):TTreeNode;
    procedure Cerca(Percorso:String;Nodo:TTreeNode);
  public
    { Public declarations }
    constructor Create(AOwner: TComponent); override;
    Destructor Destroy; override;
  published
    { Published declarations }
    Property BasePath : String Read Percorso Write Set_Percorso;
    property ShowButtons;
    property BorderStyle;
    property DragCursor;
    property ShowLines;
    property ShowRoot;
    property ReadOnly;
    property DragMode;
    property HideSelection;
    property Indent;
    property Items;
    property OnEditing;
    property OnEdited;
    property OnExpanding;
    property OnExpanded;
    property OnCollapsing;
    property OnCompare;
    property OnCollapsed;
    property OnChanging;
    property OnChange;
    property OnDeletion;
    property OnGetImageIndex;
    property OnGetSelectedIndex;
    property Align;
    property Enabled;
    property Font;
    property Color;
    property ParentColor;
    property ParentCtl3D;
    property Ctl3D;
    property SortType;
    property TabOrder;
    property TabStop default True;
    property Visible;
    property OnClick;
    property OnEnter;
    property OnExit;
    property OnDragDrop;
    property OnDragOver;
    property OnStartDrag;
    property OnEndDrag;
    property OnMouseDown;
    property OnMouseMove;
    property OnMouseUp;
    property OnDblClick;
    property OnKeyDown;
    property OnKeyPress;
    property OnKeyUp;
    property PopupMenu;
    property ParentFont;
    property ParentShowHint;
    property ShowHint;
//    property Images;
//    property StateImages;

  end;


implementation

(*$r AcFolderResource.Res *)

Uses ShellApi;

function TACTreeDir.completa_percorso(txt:String):String;
Begin
  if (Txt[Length(Txt)]<>'\') then Txt := Txt + '\';
  completa_percorso := Txt;
End;

Function TACTreeDir.agg(Nome,Completo:String;Nodo:TTreeNode):TTreeNode;
Var CNode : TTreeNode;
Begin
  CNode := Items.AddChild(Nodo,Nome); //Elenco.Selected
  CNode.ImageIndex := 0;
  CNode.SelectedIndex := 1;
  agg := CNode;

End;

procedure TACTreeDir.Cerca(Percorso:String;Nodo:TTreeNode);
Var Result : Integer;
    F: TSearchRec;
    Nuovo : TTreeNode;
    Lun1,
    Lun2   : Integer;
Begin
    Percorso := completa_percorso(Percorso);
    Result := FindFirst(Percorso+'*.*', faDirectory, f);
    while Result = 0 do
    begin
      if (f.attr=faDirectory)and(f.Name<>'.')and(f.Name<>'..') then
      Begin
         Lun1 := Length(Percorso)+1;
         Lun2 := Length(percorso+f.name)-Lun1+1;
         Nuovo := agg(Copy(percorso+f.name,Lun1,Lun2), Percorso ,Nodo);
         Cerca(Percorso+f.name,Nuovo);
      End;
      Result := FindNext(f);
    end;
    FindClose(f);
End;


constructor TACTreeDir.Create(AOwner: TComponent);
Begin
  Inherited;
  ImgLst := TImageList.Create(Self);
  Img1 := TBitMap.Create;
  Img2 := TBitMap.Create;
  Img2.LoadFromResourceName(hInstance,'TACFOLDERCLOSE');
  Img1.LoadFromResourceName(hInstance,'TACFOLDEROPEN');
  ImgLst.AddMasked(Img2,Img2.Canvas.Pixels[0,0]);
  ImgLst.AddMasked(Img1,Img1.Canvas.Pixels[0,0]);
  Images := ImgLst;
End;


Destructor TACTreeDir.Destroy;
Begin
/////////  ImgLst.Free;
  Inherited;
End;

Procedure TACTreeDir.Set_Percorso(Txt:String);
Var
    Nuovo : TTreeNode;
Begin
  Items.BeginUpdate;
  SortType := stNone;
  Items.Clear;
  Percorso := txt;
  Nuovo := agg(Percorso, Percorso ,Nil);
  Cerca(Percorso,Nuovo);
  Items.EndUpdate;
End;

end.
(*
  TTreeView = class(TCustomTreeView)
  published
    property ShowButtons;
    property BorderStyle;
    property DragCursor;
    property ShowLines;
    property ShowRoot;
    property ReadOnly;
    property DragMode;
    property HideSelection;
    property Indent;
    property Items;
    property OnEditing;
    property OnEdited;
    property OnExpanding;
    property OnExpanded;
    property OnCollapsing;
    property OnCompare;
    property OnCollapsed;
    property OnChanging;
    property OnChange;
    property OnDeletion;
    property OnGetImageIndex;
    property OnGetSelectedIndex;
    property Align;
    property Enabled;
    property Font;
    property Color;
    property ParentColor;
    property ParentCtl3D;
    property Ctl3D;
    property SortType;
    property TabOrder;
    property TabStop default True;
    property Visible;
    property OnClick;
    property OnEnter;
    property OnExit;
    property OnDragDrop;
    property OnDragOver;
    property OnStartDrag;
    property OnEndDrag;
    property OnMouseDown;
    property OnMouseMove;
    property OnMouseUp;
    property OnDblClick;
    property OnKeyDown;
    property OnKeyPress;
    property OnKeyUp;
    property PopupMenu;
    property ParentFont;
    property ParentShowHint;
    property ShowHint;
    property Images;
    property StateImages;
  end;
  *)

