(******************************************************************************
 *                                                                            *
 ******************************************************************************)
unit Fn_book;

(******************************************************************************
 *                                                                            *
 ******************************************************************************)
interface

{******************************************************************************
 *                                                                            *
 ******************************************************************************}
Uses StdCtrls;

{******************************************************************************
 * COSTANTI                                                                   *
 ******************************************************************************}
Const BOOK_PER_SCHEDA = 7;
      BOOK_PER_RICERCA = 50;

{******************************************************************************
 * Type                                                                       *
 *                                                                            *
 *                                                                            *
 * Nel primo record                                                           *
 *    Codice: Indica il codice dell'ultimo libro inserito                     *
 *    Precedente: Indica il codice del primo libro                            *
 *    Successivo: Indica il codice dell'ultimo libro                          *
 ******************************************************************************}
Type rec_book = record
     Codice          : Integer;
     Titolo          : String[50];
     Autore          : String[50];
     Editore         : String[20];
     Genere          : String[20];
     Posizione       : String[10];
     Codice_Prestito : integer;
     Data_Prestito   : String[10];
     Argomenti       : String[100];
     Cancellato      : Boolean;
     Precedente      : Integer;
     Successivo      : Integer;
     Vari1           : Integer;
     Vari2           : Integer;
     Vari3           : String[10];
     Vari4           : String[10];

     end;
     cnq_rec_book    = array[1..BOOK_PER_RICERCA] of rec_book;
{******************************************************************************
 *                                                                            *
 ******************************************************************************}
Var
  bb_codice,
  bb_titolo,
  bb_autore,
  bb_editore,
  bb_genere : array[1..BOOK_PER_SCHEDA] of TLabel;


 Book_Browse_Primo  : Integer;
 Book_Corrente      : integer;
 Dati_Book_Corrente : rec_book;
{******************************************************************************
 *                                                                            *
 ******************************************************************************}

function book_nome_archivio:String;

Procedure book_Reset(var x:rec_book);

Procedure book_Registra_Nuovo(x:rec_book);

function book_get_numero : integer;

Procedure book_Leggi(Var x:rec_book;num:integer);

function book_Leggi_50(Var x:cnq_rec_book;num:integer):integer;

function book_cerca(campo:String;primo_da_cercare:Integer):integer;

function book_next_codice : integer;

procedure book_compila_browse;

Procedure book_compila(app1 : rec_book;Flag:Integer);

procedure book_set_codice_ultimo_progressivo(cod:integer);

function book_cerca_per_codice(Var x:rec_book;num:string;Cancellati:Boolean):Integer;

Procedure book_Scrive(Var x:rec_book;num:integer);

procedure book_set_prestito(libro, persona:integer);

function book_nome_archivio_temp:String;

procedure book_Cancella(Codice:Integer);

procedure book_recupera_dati_form(var x : rec_book);

Procedure book_scrivi(x:rec_book;num:integer);

function book_compara(x1,x2:rec_book):Boolean;

function book_compara_str(txt:String;x2:rec_book):Boolean;

function book_get_stato_archivio:Integer;

function book_cerca_simple(Codice:integer):Integer;

function book_get_codice_primo:Integer;

function book_get_codice_ultimo:Integer;

function book_ritorna_move(corrente,dove:integer):Integer;

(******************************************************************************
 *                                                                            *
 ******************************************************************************)
implementation

{***************************************************************************
 *                                                                         *
 ***************************************************************************}
Uses Vari, sysUtils, form_main, Graphics;


{******************************************************************************
 * Book Get Codice Primo                                                      *
 *                                                                            *
 * Ottiene il codice del primo libro                                          *
 ******************************************************************************}
function book_get_codice_primo:Integer;
Var x:rec_book;
begin
  book_Leggi(x,0);
  book_get_codice_primo := x.Precedente;
end;

{******************************************************************************
 * Book Get Codice Ultimo                                                     *
 *                                                                            *
 * Ottiene il codice dell'ultimo                                              *
 ******************************************************************************}
function book_get_codice_ultimo:Integer;
Var x:rec_book;
begin
  book_Leggi(x,0);
  book_get_codice_ultimo := x.Successivo;
end;


(******************************************************************************
 * book_ritorna_move                                                          *
 *                                                                            *
 * Nome      Descrizione                                                      *
 * --------- ---------------------------------------------------------------- *
 * Corrente  Codice corrente                                                  *
 * dove      -1 Ritorna il codice del libro precedente                        *
 *           +1 Ritorna il codice del libro successivo                        *
 ******************************************************************************)
function book_ritorna_move(corrente,dove:integer):Integer;
Var r1 : Integer;
    app1 : Rec_Book;
begin
  r1 := Corrente;
  book_Leggi(app1,book_cerca_simple(Corrente));
  if (dove=+1) then r1:=App1.Successivo
  else if (dove=-1) then r1:=App1.Precedente;
  book_ritorna_move := r1;
end;
(******************************************************************************
 *                                                                            *
 ******************************************************************************)
procedure book_set_codice_primo_ultimo(numero:integer;primo:boolean);
var x : rec_book;
    f : integer;

begin
   f := FileOpen(book_nome_archivio,fmOpenReadWrite);
   if (FileSeek(f, 0, 2)>0) then // Lunghezza file
   begin // Se il file non  vuoto legge il codice precedente
     FileSeek(f, 0, 0);
     FileRead(f, x, SizeOf(x));
   end
   else  // Altrimenti genera un codice nuovo
   begin
     book_Reset(x);
   end;
   if(primo) then x.Precedente := numero
   else x.Successivo := numero;
   FileSeek(f, 0, 0);
   FileWrite(f, x, SizeOf(x));
   FileClose(f);

end;

{***************************************************************************
 * Book_setta_Successivo_a                                                 *
 *                                                                         *
 * Setta il nuovo successivo di un determinato Record                      *
 ***************************************************************************}
Procedure Book_setta_Successivo_a(Codice, nuova_dest : Integer);
Var x : rec_Book;
Begin
  Codice := book_cerca_per_codice(x,IntToStr(Codice),False);
  if (Codice>0) then
  begin
    book_Leggi(x,Codice);
    x.Successivo := nuova_Dest;
    book_Scrivi(x,Codice);
  end;
End;

{***************************************************************************
 * Book_setta_Precedente_a                                                 *
 *                                                                         *
 * Setta il nuovo precedente di un determinato Record                      *
 ***************************************************************************}
Procedure Book_setta_Precedente_a(Codice, nuova_dest : Integer);
Var x : rec_Book;
Begin
  Codice := book_cerca_per_codice(x,IntToStr(Codice),False);
  if (Codice>0) then
  begin
    book_Leggi(x,Codice);
    x.Precedente := nuova_Dest;
    book_Scrivi(x,Codice);
  end;
End;

{***************************************************************************
 *                                                                         *
 ***************************************************************************}
function book_nome_archivio:String;
Begin
  book_nome_archivio := completa_percorso(cur_path)+'book\book.dat';
end;

{***************************************************************************
 *                                                                         *
 ***************************************************************************}
function book_nome_archivio_temp:String;
Begin
  book_nome_archivio_temp := completa_percorso(cur_path)+'book\book.tmp';
end;

{******************************************************************************
 *                                                                            *
 ******************************************************************************}
Procedure book_Reset(var x:rec_book);
Begin
     fillchar(x,sizeof(x),0);
     x.Codice          := 0;
     x.Titolo          := '';
     x.Autore          := '';
     x.Editore         := '';
     x.Genere          := '';
     x.Posizione       := '';
     x.Codice_Prestito := 0;
     x.Data_Prestito   := '';
     x.Argomenti       := '';
     x.Cancellato      := False;
     x.Precedente      := -1;
     x.Successivo      := -1;

     x.Vari1           := 0;
     x.Vari2           := 0;
     x.Vari3           := '';
     x.Vari4           := '';
End;

{******************************************************************************
 * Crea Archivio                                                              *
 ******************************************************************************}
procedure Book_crea_Archivio(nome:string);
Var f    : Integer;
begin
  if (not fileexists(nome)) Then
  begin
    f := FileCreate(nome);
    FileClose(f);
    book_set_codice_ultimo_progressivo(0); // Inizializza il codice
  end;
end;
{******************************************************************************
 *                                                                            *
 ******************************************************************************}
Procedure book_Registra_Nuovo(x:rec_book);
Var f    : Integer;
Begin
   Book_crea_Archivio(book_nome_archivio);

   Try

     x.successivo:= x.codice;
     if (book_get_codice_ultimo=-1) then x.precedente:= x.codice
     else
     begin
       Book_setta_Successivo_a(book_get_codice_ultimo,x.codice);
       x.precedente := book_get_codice_ultimo; // Setto il libro precedente
     end;
     f := FileOpen(book_nome_archivio,fmOpenWrite);
     FileSeek(f, 0, 2); // Si posiziona alla fine
     FileWrite(f, x, SizeOf(x));
     FileClose(f);

     book_set_codice_ultimo_progressivo(x.codice); // Registra l'ultimo codice
     book_set_codice_primo_ultimo(x.codice,false);
     if (book_get_codice_primo=-1) then book_set_codice_primo_ultimo(x.codice,True);
     //if (book_get_codice_ultimo=-1) then book_set_codice_primo_ultimo(x.codice,True);
   except
   end;

End;

{******************************************************************************
 *                                                                            *
 ******************************************************************************}
function book_get_numero : integer;
Var f, app1 : Integer;
Begin
   //if (not fileexists(book_nome_archivio)) Then f := FileCreate(book_nome_archivio)
   if (Fileexists(book_nome_archivio)) then
   begin
     f := FileOpen(book_nome_archivio,fmOpenRead);
     app1 := (FileSeek(f, 0, 2) div sizeof(rec_book)) - 1;
     if (app1<0) then app1 := 0;
     book_get_numero := app1 ; // Toglie il primo record che  di controllo per il programma
     FileClose(f);
   end
   else
   begin
     book_get_numero := 0;
   end;
End;

{******************************************************************************
 * book leggi                                                                 *
 *                                                                            *
 * Legge i dati di un libro                                                   *
 *                                                                            *
 * Nome        Descrizione                                                    *
 * ----------- -------------------------------------------------------------- *
 * rec_book    Buffer dove caricare i dati                                    *
 * num         Numero del record (NON e' il codice del libro, ma la           *
 *                                posizione nel file                          *
 ******************************************************************************}
Procedure book_Leggi(Var x:rec_book;num:integer);
Var f : Integer;
Begin
   //if (not fileexists(book_nome_archivio)) Then f := FileCreate(book_nome_archivio)

   //dec(num);
   book_Reset(x);
   if (num<=book_get_numero) then
   Begin
     f := FileOpen(book_nome_archivio,fmOpenRead);
     FileSeek(f, num*SizeOf(x), 0);
     FileRead(f, x, SizeOf(x));

//     Book_Corrente :=

     FileClose(f);
   end;

End;

{******************************************************************************
 * book scrive                                                                *
 *                                                                            *
 * Scrive i dati di un libro                                                  *
 *                                                                            *
 * Nome        Descrizione                                                    *
 * ----------- -------------------------------------------------------------- *
 * rec_book    Buffer dei dati                                                *
 * num         Numero del record (NON e' il codice del libro, ma la posizione *
 *                                nel file                                    *
 ******************************************************************************}
Procedure book_Scrive(Var x:rec_book;num:integer);
Var f : Integer;
Begin
   //if (not fileexists(book_nome_archivio)) Then f := FileCreate(book_nome_archivio)

   //dec(num);
   if (num<=book_get_numero) then
   Begin
     f := FileOpen(book_nome_archivio,fmOpenWrite);
     FileSeek(f, num*SizeOf(x), 0); // Si posiziona alla fine
     FileWrite(f, x, SizeOf(x));
//     Book_Corrente :=
     FileClose(f);
   end;

End;

{******************************************************************************
 * Book scrivi                                                                *
 *                                                                            *
 *                                                                            *
 * Nome          Descrizione                                                  *
 * ------------- ------------------------------------------------------------ *
 * x             Buffer dove inserire i dati del libro                        *
 * num           Numero del record da leggere  (NON  il codice libro)        *
 ******************************************************************************}
Procedure book_scrivi(x:rec_book;num:integer);
Var f : Integer;
Begin
   //if (not fileexists(soci_nome_archivio)) Then f := FileCreate(soci_nome_archivio)
   if (num=0) then num := 1;
   if (num<=book_get_numero) then
   Begin
     f := FileOpen(book_nome_archivio,fmOpenWrite);
     FileSeek(f, num*SizeOf(x), 0); // Si posiziona alla fine
     FileWrite(f, x, SizeOf(x));
     FileClose(f);
   end;

End;

{***************************************************************************
 *                                                                         *
 ***************************************************************************}
function book_compara(x1,x2:rec_book):Boolean;
Var fl : Boolean;
begin
   fl := True;
   if (x1.codice>0) then fl := fl or (x1.codice=x2.codice);
   fl := fl and compara_valori_simple(x1.Titolo     , x2.Titolo);
   fl := fl and compara_valori_simple(x1.Autore     , x2.Autore);
   fl := fl and compara_valori_simple(x1.Editore    , x2.Editore);
   fl := fl and compara_valori_simple(x1.Genere     , x2.Genere);
   fl := fl and compara_valori_simple(x1.Posizione  , x2.Posizione);
   fl := fl and compara_valori_simple(x1.Argomenti  , x2.Argomenti); // Utile ??????
   fl := fl and compara_valori_simple(x1.Posizione  , x2.Posizione);
   book_compara := fl;

end;

{***************************************************************************
 *                                                                         *
 ***************************************************************************}
function book_compara_str(txt:String;x2:rec_book):Boolean;
Var fl : Boolean;
begin
   fl := False;
   fl := fl or compara_valori_simple(txt, IntToStr(x2.codice));
   fl := fl or compara_valori_simple(txt, x2.Titolo);
   fl := fl or compara_valori_simple(txt, x2.Autore);
   fl := fl or compara_valori_simple(txt, x2.Editore);
   fl := fl or compara_valori_simple(txt, x2.Genere);
   fl := fl or compara_valori_simple(txt, x2.Posizione);
   fl := fl or compara_valori_simple(txt, x2.Argomenti); // Utile ??????
   fl := fl or compara_valori_simple(txt, x2.Posizione);
   book_compara_str := fl;

end;

{***************************************************************************
 *                                                                         *
 ***************************************************************************}
function book_cerca(Campo:String;primo_da_cercare:Integer):integer;
var primo,c2,c3    : integer;
    //app2        : sette_rec_book;
    fl          : Boolean;
    app1        : cnq_rec_book;


Begin
  if (primo_da_cercare=0) then primo := 1
  else Primo := primo_da_Cercare;
  c2 := 1;
  while (c2<>0) do
  begin
    c2 := book_Leggi_50(app1,primo);
    //fl := fl and
    for c3 := 1 to c2 do
    begin
      if (app1[c3].Cancellato=false) then
      begin
        fl := book_compara_str(Campo,app1[c3]);

        if (fl) then
        Begin
          book_cerca := primo+c3-1;
          exit;
        End;
      end;
    end;
    primo := primo+c2;
  end;
  book_cerca := -1;
End;

{***************************************************************************
 *                                                                         *
 ***************************************************************************}
function book_next_codice : integer;
var x : rec_book;
Begin
  book_Leggi(x,0);
  if (x.codice=0) then x.codice := 1000;
  book_next_codice := x.codice+1;
End;

{***************************************************************************
 *                                                                         *
 ***************************************************************************}
procedure book_compila_browse;
var x : rec_book;
    c1, old, corrente : integer;
    colore : Tcolor;
Begin
 old := -1;
 if (Book_Browse_Primo <=0) then Book_Browse_Primo := book_get_codice_primo;
 if (Book_Browse_Primo >=book_get_codice_ultimo) then Book_Browse_Primo := book_get_codice_ultimo;
 Corrente := Book_Browse_Primo;

 for c1 := 1 to BOOK_PER_SCHEDA do
 begin
   Book_Leggi(x,book_cerca_simple(Corrente));

   if (corrente=old)or(corrente=-1) then
   begin
     book_reset(x);
   end;

   if (x.Codice>0) then bb_codice[c1].caption := IntToStr(x.Codice)
   else bb_codice[c1].caption := '';
   bb_titolo[c1].caption      := x.Titolo;
   bb_Autore[c1].caption      := x.Autore;
   bb_Editore[c1].caption     := x.Editore;
   bb_Genere[c1].caption      := x.Genere;

   if (x.Codice_Prestito>0) then Colore := clBlue
   else Colore := clWindowText;

   bb_codice[c1].font.color  := Colore;
   bb_titolo[c1].font.color  := Colore;
   bb_Autore[c1].font.color  := Colore;
   bb_Editore[c1].font.color := Colore;
   bb_Genere[c1].font.color  := Colore;

   Old := Corrente;
   Corrente := x.Successivo;


 end;

End;


(******************************************************************************
 * Book Compila                                                               *
 *                                                                            *
 * Nome        Descrizione                                                    *
 * ----------- -------------------------------------------------------------- *
 * App1        Dati da scrivere                                               *
 * Flag        0: Scrive tutto                                                *
 *             1: Non compila il codice ne il campo posizione                 *
 ******************************************************************************)
Procedure book_compila(app1 : rec_book;Flag:Integer);
Begin
  if (Flag<>1) Then
  Begin
    if (app1.codice<=0) then form1.ed_Book_Codice.Text := ''
    else form1.ed_Book_Codice.Text          := IntToStr(app1.codice);
  end;
  form1.ed_Book_Titolo.Text          := app1.Titolo;
  form1.ed_Book_Autore.Text          := app1.Autore;
  form1.ed_Book_Editore.Text         := app1.Editore;
  form1.ed_Book_Genere.Text          := app1.Genere;
  if (Flag<>1) Then form1.ed_Book_Posizione.Text       := app1.Posizione;
  form1.ed_Book_Prestito.Text        := IntToStr(app1.Codice_Prestito);
  form1.ed_Book_Data_Prestito.Text   := app1.Data_Prestito;
  form1.ed_Book_Argomenti.Text       := app1.Argomenti;


End;


(******************************************************************************
 *                                                                            *
 ******************************************************************************)
procedure book_set_codice_ultimo_progressivo(cod:integer);
var x : rec_book;
    f : integer;

begin
   f := FileOpen(book_nome_archivio,fmOpenReadWrite);
   if (FileSeek(f, 0, 2)>0) then // Lunghezza file
   begin // Se il file non  vuoto legge il codice precedente
     FileSeek(f, 0, 0);
     FileRead(f, x, SizeOf(x));
   end
   else  // Altrimenti genera un codice nuovo
   begin
     book_Reset(x);
   end;
   x.codice := cod;
   FileSeek(f, 0, 0);
   FileWrite(f, x, SizeOf(x));
   FileClose(f);

end;

{***************************************************************************
 *                                                                         *
 ***************************************************************************}
function book_cerca_per_codice(Var x:rec_book;num:string;Cancellati:Boolean):Integer;
var primo, ultimo, corrente, cercato : integer;
    trovato : Integer;
    temp    : rec_book;
    flag    : Boolean;
begin
  Primo := 1;
  Ultimo := book_get_numero;
  Trovato := -1;
  if(ATOI(Num)>0) then
  begin
    num := trim(num);
    if (num<>'') then
    begin
      num := uppercase(num);
      cercato := aTOi(num);
      while ((Primo<=Ultimo)and(trovato=-1)) do
      begin
        Corrente := (Primo+Ultimo) div 2;
        book_Leggi(temp,corrente);
        if (temp.codice=cercato) then
        begin
          if(Cancellati) then Flag := True
          else Flag := Not temp.cancellato;

          x := temp;
          if (flag) then Trovato := corrente
          else Break;
        end
        else
        begin
          if (temp.codice<cercato) then primo := corrente+1
          else if (temp.codice>cercato) then ultimo := corrente-1
        end
      end;

    end;
  end;
  book_cerca_per_codice := Trovato;
end;

{******************************************************************************
 *                                                                            *
 ******************************************************************************}
function book_Leggi_50(Var x:cnq_rec_book;num:integer):integer;
Var f : Integer;
    c1,c2 : integer;
Begin
   //if (not fileexists(book_nome_archivio)) Then f := FileCreate(book_nome_archivio)

   //dec(num);
   for c1 := 1 to BOOK_PER_RICERCA do
   Begin
     book_Reset(x[c1]);
   End;
   c1 := 0; // Numero record letti
   if (num<=book_get_numero) then
   Begin
     f := FileOpen(book_nome_archivio,fmOpenRead);
     FileSeek(f, num*SizeOf(rec_book), 0); // Si posiziona alla fine
     c1 := FileRead(f, x, SizeOf(rec_book) * BOOK_PER_SCHEDA);
     c1 := c1 div sizeof(rec_book); // Numero record letti
     FileClose(f);
   end;
   for c2 := 1 to BOOK_PER_RICERCA do
   Begin
     if (x[c2].cancellato) then book_Reset(x[c2]);
   End;
   book_Leggi_50 := c1;
End;

{******************************************************************************
 *                                                                            *
 ******************************************************************************}
procedure book_set_prestito(libro, persona:integer);
Var x  : rec_book;
    c1 : integer;
begin
 c1 := book_cerca_per_codice(x,IntToStr(libro),False);
 if(c1>0) then
 Begin
   x.Codice_Prestito := persona;
   x.Data_Prestito   := DateToStr(Now);
   book_Scrive(x,c1);
 End;
end;

{******************************************************************************
 *                                                                            *
 ******************************************************************************}
procedure book_Cancella(Codice:Integer);
var app1          : rec_book;
    Cercato        : Integer;
begin

  Cercato := book_cerca_simple(Codice);
  Book_Leggi(app1,Cercato);
  App1.Cancellato := True;
  Book_Scrivi(app1,Cercato);
  if (Codice<=book_get_codice_primo)or(App1.Codice=app1.Precedente) then // Se e' il primo
  begin
    if (Codice>=book_get_codice_ultimo) then // se e' un record unico
    begin
      book_set_codice_primo_ultimo(-1,false);
      book_set_codice_primo_ultimo(-1,true);
    end
    else
    begin
      book_set_codice_primo_ultimo(app1.successivo,true);
      Book_setta_Precedente_a(App1.Successivo, App1.Successivo);
    end;
  end
  else if (Codice>=book_get_codice_ultimo)or(App1.Codice=app1.Successivo) then // Se e' l'ultimo
  begin
    if (Codice<=book_get_codice_primo) then // se e' un record unico
    begin
      book_set_codice_primo_ultimo(-1,false);
      book_set_codice_primo_ultimo(-1,true);
    end
    else
    begin
      book_set_codice_primo_ultimo(app1.precedente,false);
      Book_setta_Successivo_a(App1.Precedente, App1.Precedente);
    end;
  end
  else  // Altrimenti
  begin
    Book_setta_Successivo_a(App1.Precedente, App1.Successivo);
    Book_setta_Precedente_a(App1.Successivo, App1.Precedente);
  end;
end;

{******************************************************************************
 *                                                                            *
 ******************************************************************************}
procedure book_recupera_dati_form(var x : rec_book);
begin
  x.Codice           := aTOi(form1.ed_Book_Codice.text);
  x.Titolo           := form1.ed_Book_Titolo.Text;
  x.Autore           := form1.ed_Book_Autore.Text;
  x.Editore          := form1.ed_Book_Editore.Text;
  x.Genere           := form1.ed_Book_Genere.Text;
  x.Posizione        := form1.ed_Book_Posizione.Text;
  x.Codice_Prestito  := aTOi(form1.ed_Book_Prestito.Text);
  x.Data_Prestito    := form1.ed_Book_Data_Prestito.Text;
  x.Argomenti        := form1.ed_Book_Argomenti.Text;
end;

{******************************************************************************
 *                                                                            *
 ******************************************************************************}
function book_get_stato_archivio:Integer;
begin
  book_get_stato_archivio := stato_file(book_Nome_Archivio);
End;

{******************************************************************************
 *                                                                            *
 ******************************************************************************}
function book_cerca_simple(Codice:integer):Integer;
Var app : rec_book;
Begin
  book_cerca_simple := book_cerca_per_codice(app,IntToStr(codice),True);
End;

end. //813
